package org.eclipse.lsat.machine.teditor.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.eclipse.lsat.machine.teditor.services.MachineGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

/**
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Do not edit: This file is generated by Xtext
 */
@SuppressWarnings("all")
public class InternalMachineParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_STRING", "RULE_INT", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'Machine'", "'PathAnnotations'", "'{'", "'}'", "'import'", "'PeripheralType'", "'Actions'", "'SetPoints'", "'Axes'", "'Conversion'", "'['", "']'", "'moves'", "','", "'Resource'", "'('", "')'", "':'", "'AxisPositions'", "'SymbolicPositions'", "'Profiles'", "'Distances'", "'Paths'", "'.'", "'-->'", "'profiles'", "'profile'", "'@'", "'<->'", "'FullMesh'"
    };
    public static final int RULE_STRING=5;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__37=37;
    public static final int T__16=16;
    public static final int T__38=38;
    public static final int T__17=17;
    public static final int T__39=39;
    public static final int T__18=18;
    public static final int T__11=11;
    public static final int T__33=33;
    public static final int T__12=12;
    public static final int T__34=34;
    public static final int T__13=13;
    public static final int T__35=35;
    public static final int T__14=14;
    public static final int T__36=36;
    public static final int EOF=-1;
    public static final int T__30=30;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int RULE_ID=4;
    public static final int RULE_WS=9;
    public static final int RULE_ANY_OTHER=10;
    public static final int T__26=26;
    public static final int T__27=27;
    public static final int T__28=28;
    public static final int RULE_INT=6;
    public static final int T__29=29;
    public static final int T__22=22;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__23=23;
    public static final int T__24=24;
    public static final int T__25=25;
    public static final int T__40=40;
    public static final int T__20=20;
    public static final int T__21=21;

    // delegates
    // delegators


        public InternalMachineParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalMachineParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalMachineParser.tokenNames; }
    public String getGrammarFileName() { return "InternalMachine.g"; }



     	private MachineGrammarAccess grammarAccess;

        public InternalMachineParser(TokenStream input, MachineGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "Machine";
       	}

       	@Override
       	protected MachineGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleMachine"
    // InternalMachine.g:72:1: entryRuleMachine returns [EObject current=null] : iv_ruleMachine= ruleMachine EOF ;
    public final EObject entryRuleMachine() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMachine = null;


        try {
            // InternalMachine.g:72:48: (iv_ruleMachine= ruleMachine EOF )
            // InternalMachine.g:73:2: iv_ruleMachine= ruleMachine EOF
            {
             newCompositeNode(grammarAccess.getMachineRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMachine=ruleMachine();

            state._fsp--;

             current =iv_ruleMachine; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMachine"


    // $ANTLR start "ruleMachine"
    // InternalMachine.g:79:1: ruleMachine returns [EObject current=null] : ( () ( (lv_imports_1_0= ruleImport ) )* (otherlv_2= 'Machine' ( (lv_type_3_0= RULE_ID ) ) )? (otherlv_4= 'PathAnnotations' otherlv_5= '{' ( (lv_pathAnnotations_6_0= rulePathAnnotation ) )* otherlv_7= '}' )? ( ( (lv_peripheralTypes_8_0= rulePeripheralType ) ) | ( (lv_resources_9_0= ruleResource ) ) )* ) ;
    public final EObject ruleMachine() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token lv_type_3_0=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_7=null;
        EObject lv_imports_1_0 = null;

        EObject lv_pathAnnotations_6_0 = null;

        EObject lv_peripheralTypes_8_0 = null;

        EObject lv_resources_9_0 = null;



        	enterRule();

        try {
            // InternalMachine.g:85:2: ( ( () ( (lv_imports_1_0= ruleImport ) )* (otherlv_2= 'Machine' ( (lv_type_3_0= RULE_ID ) ) )? (otherlv_4= 'PathAnnotations' otherlv_5= '{' ( (lv_pathAnnotations_6_0= rulePathAnnotation ) )* otherlv_7= '}' )? ( ( (lv_peripheralTypes_8_0= rulePeripheralType ) ) | ( (lv_resources_9_0= ruleResource ) ) )* ) )
            // InternalMachine.g:86:2: ( () ( (lv_imports_1_0= ruleImport ) )* (otherlv_2= 'Machine' ( (lv_type_3_0= RULE_ID ) ) )? (otherlv_4= 'PathAnnotations' otherlv_5= '{' ( (lv_pathAnnotations_6_0= rulePathAnnotation ) )* otherlv_7= '}' )? ( ( (lv_peripheralTypes_8_0= rulePeripheralType ) ) | ( (lv_resources_9_0= ruleResource ) ) )* )
            {
            // InternalMachine.g:86:2: ( () ( (lv_imports_1_0= ruleImport ) )* (otherlv_2= 'Machine' ( (lv_type_3_0= RULE_ID ) ) )? (otherlv_4= 'PathAnnotations' otherlv_5= '{' ( (lv_pathAnnotations_6_0= rulePathAnnotation ) )* otherlv_7= '}' )? ( ( (lv_peripheralTypes_8_0= rulePeripheralType ) ) | ( (lv_resources_9_0= ruleResource ) ) )* )
            // InternalMachine.g:87:3: () ( (lv_imports_1_0= ruleImport ) )* (otherlv_2= 'Machine' ( (lv_type_3_0= RULE_ID ) ) )? (otherlv_4= 'PathAnnotations' otherlv_5= '{' ( (lv_pathAnnotations_6_0= rulePathAnnotation ) )* otherlv_7= '}' )? ( ( (lv_peripheralTypes_8_0= rulePeripheralType ) ) | ( (lv_resources_9_0= ruleResource ) ) )*
            {
            // InternalMachine.g:87:3: ()
            // InternalMachine.g:88:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getMachineAccess().getMachineAction_0(),
            					current);
            			

            }

            // InternalMachine.g:94:3: ( (lv_imports_1_0= ruleImport ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==15) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalMachine.g:95:4: (lv_imports_1_0= ruleImport )
            	    {
            	    // InternalMachine.g:95:4: (lv_imports_1_0= ruleImport )
            	    // InternalMachine.g:96:5: lv_imports_1_0= ruleImport
            	    {

            	    					newCompositeNode(grammarAccess.getMachineAccess().getImportsImportParserRuleCall_1_0());
            	    				
            	    pushFollow(FOLLOW_3);
            	    lv_imports_1_0=ruleImport();

            	    state._fsp--;


            	    					if (current==null) {
            	    						current = createModelElementForParent(grammarAccess.getMachineRule());
            	    					}
            	    					add(
            	    						current,
            	    						"imports",
            	    						lv_imports_1_0,
            	    						"org.eclipse.lsat.machine.teditor.Machine.Import");
            	    					afterParserOrEnumRuleCall();
            	    				

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            // InternalMachine.g:113:3: (otherlv_2= 'Machine' ( (lv_type_3_0= RULE_ID ) ) )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==11) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // InternalMachine.g:114:4: otherlv_2= 'Machine' ( (lv_type_3_0= RULE_ID ) )
                    {
                    otherlv_2=(Token)match(input,11,FOLLOW_4); 

                    				newLeafNode(otherlv_2, grammarAccess.getMachineAccess().getMachineKeyword_2_0());
                    			
                    // InternalMachine.g:118:4: ( (lv_type_3_0= RULE_ID ) )
                    // InternalMachine.g:119:5: (lv_type_3_0= RULE_ID )
                    {
                    // InternalMachine.g:119:5: (lv_type_3_0= RULE_ID )
                    // InternalMachine.g:120:6: lv_type_3_0= RULE_ID
                    {
                    lv_type_3_0=(Token)match(input,RULE_ID,FOLLOW_5); 

                    						newLeafNode(lv_type_3_0, grammarAccess.getMachineAccess().getTypeIDTerminalRuleCall_2_1_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getMachineRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"type",
                    							lv_type_3_0,
                    							"org.eclipse.xtext.common.Terminals.ID");
                    					

                    }


                    }


                    }
                    break;

            }

            // InternalMachine.g:137:3: (otherlv_4= 'PathAnnotations' otherlv_5= '{' ( (lv_pathAnnotations_6_0= rulePathAnnotation ) )* otherlv_7= '}' )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==12) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // InternalMachine.g:138:4: otherlv_4= 'PathAnnotations' otherlv_5= '{' ( (lv_pathAnnotations_6_0= rulePathAnnotation ) )* otherlv_7= '}'
                    {
                    otherlv_4=(Token)match(input,12,FOLLOW_6); 

                    				newLeafNode(otherlv_4, grammarAccess.getMachineAccess().getPathAnnotationsKeyword_3_0());
                    			
                    otherlv_5=(Token)match(input,13,FOLLOW_7); 

                    				newLeafNode(otherlv_5, grammarAccess.getMachineAccess().getLeftCurlyBracketKeyword_3_1());
                    			
                    // InternalMachine.g:146:4: ( (lv_pathAnnotations_6_0= rulePathAnnotation ) )*
                    loop3:
                    do {
                        int alt3=2;
                        int LA3_0 = input.LA(1);

                        if ( (LA3_0==RULE_ID) ) {
                            alt3=1;
                        }


                        switch (alt3) {
                    	case 1 :
                    	    // InternalMachine.g:147:5: (lv_pathAnnotations_6_0= rulePathAnnotation )
                    	    {
                    	    // InternalMachine.g:147:5: (lv_pathAnnotations_6_0= rulePathAnnotation )
                    	    // InternalMachine.g:148:6: lv_pathAnnotations_6_0= rulePathAnnotation
                    	    {

                    	    						newCompositeNode(grammarAccess.getMachineAccess().getPathAnnotationsPathAnnotationParserRuleCall_3_2_0());
                    	    					
                    	    pushFollow(FOLLOW_7);
                    	    lv_pathAnnotations_6_0=rulePathAnnotation();

                    	    state._fsp--;


                    	    						if (current==null) {
                    	    							current = createModelElementForParent(grammarAccess.getMachineRule());
                    	    						}
                    	    						add(
                    	    							current,
                    	    							"pathAnnotations",
                    	    							lv_pathAnnotations_6_0,
                    	    							"org.eclipse.lsat.machine.teditor.Machine.PathAnnotation");
                    	    						afterParserOrEnumRuleCall();
                    	    					

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop3;
                        }
                    } while (true);

                    otherlv_7=(Token)match(input,14,FOLLOW_8); 

                    				newLeafNode(otherlv_7, grammarAccess.getMachineAccess().getRightCurlyBracketKeyword_3_3());
                    			

                    }
                    break;

            }

            // InternalMachine.g:170:3: ( ( (lv_peripheralTypes_8_0= rulePeripheralType ) ) | ( (lv_resources_9_0= ruleResource ) ) )*
            loop5:
            do {
                int alt5=3;
                int LA5_0 = input.LA(1);

                if ( (LA5_0==16) ) {
                    alt5=1;
                }
                else if ( (LA5_0==25) ) {
                    alt5=2;
                }


                switch (alt5) {
            	case 1 :
            	    // InternalMachine.g:171:4: ( (lv_peripheralTypes_8_0= rulePeripheralType ) )
            	    {
            	    // InternalMachine.g:171:4: ( (lv_peripheralTypes_8_0= rulePeripheralType ) )
            	    // InternalMachine.g:172:5: (lv_peripheralTypes_8_0= rulePeripheralType )
            	    {
            	    // InternalMachine.g:172:5: (lv_peripheralTypes_8_0= rulePeripheralType )
            	    // InternalMachine.g:173:6: lv_peripheralTypes_8_0= rulePeripheralType
            	    {

            	    						newCompositeNode(grammarAccess.getMachineAccess().getPeripheralTypesPeripheralTypeParserRuleCall_4_0_0());
            	    					
            	    pushFollow(FOLLOW_8);
            	    lv_peripheralTypes_8_0=rulePeripheralType();

            	    state._fsp--;


            	    						if (current==null) {
            	    							current = createModelElementForParent(grammarAccess.getMachineRule());
            	    						}
            	    						add(
            	    							current,
            	    							"peripheralTypes",
            	    							lv_peripheralTypes_8_0,
            	    							"org.eclipse.lsat.machine.teditor.Machine.PeripheralType");
            	    						afterParserOrEnumRuleCall();
            	    					

            	    }


            	    }


            	    }
            	    break;
            	case 2 :
            	    // InternalMachine.g:191:4: ( (lv_resources_9_0= ruleResource ) )
            	    {
            	    // InternalMachine.g:191:4: ( (lv_resources_9_0= ruleResource ) )
            	    // InternalMachine.g:192:5: (lv_resources_9_0= ruleResource )
            	    {
            	    // InternalMachine.g:192:5: (lv_resources_9_0= ruleResource )
            	    // InternalMachine.g:193:6: lv_resources_9_0= ruleResource
            	    {

            	    						newCompositeNode(grammarAccess.getMachineAccess().getResourcesResourceParserRuleCall_4_1_0());
            	    					
            	    pushFollow(FOLLOW_8);
            	    lv_resources_9_0=ruleResource();

            	    state._fsp--;


            	    						if (current==null) {
            	    							current = createModelElementForParent(grammarAccess.getMachineRule());
            	    						}
            	    						add(
            	    							current,
            	    							"resources",
            	    							lv_resources_9_0,
            	    							"org.eclipse.lsat.machine.teditor.Machine.Resource");
            	    						afterParserOrEnumRuleCall();
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMachine"


    // $ANTLR start "entryRuleImport"
    // InternalMachine.g:215:1: entryRuleImport returns [EObject current=null] : iv_ruleImport= ruleImport EOF ;
    public final EObject entryRuleImport() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleImport = null;


        try {
            // InternalMachine.g:215:47: (iv_ruleImport= ruleImport EOF )
            // InternalMachine.g:216:2: iv_ruleImport= ruleImport EOF
            {
             newCompositeNode(grammarAccess.getImportRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleImport=ruleImport();

            state._fsp--;

             current =iv_ruleImport; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleImport"


    // $ANTLR start "ruleImport"
    // InternalMachine.g:222:1: ruleImport returns [EObject current=null] : (otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) ) ) ;
    public final EObject ruleImport() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_importURI_1_0=null;


        	enterRule();

        try {
            // InternalMachine.g:228:2: ( (otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) ) ) )
            // InternalMachine.g:229:2: (otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) ) )
            {
            // InternalMachine.g:229:2: (otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) ) )
            // InternalMachine.g:230:3: otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) )
            {
            otherlv_0=(Token)match(input,15,FOLLOW_9); 

            			newLeafNode(otherlv_0, grammarAccess.getImportAccess().getImportKeyword_0());
            		
            // InternalMachine.g:234:3: ( (lv_importURI_1_0= RULE_STRING ) )
            // InternalMachine.g:235:4: (lv_importURI_1_0= RULE_STRING )
            {
            // InternalMachine.g:235:4: (lv_importURI_1_0= RULE_STRING )
            // InternalMachine.g:236:5: lv_importURI_1_0= RULE_STRING
            {
            lv_importURI_1_0=(Token)match(input,RULE_STRING,FOLLOW_2); 

            					newLeafNode(lv_importURI_1_0, grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getImportRule());
            					}
            					setWithLastConsumed(
            						current,
            						"importURI",
            						lv_importURI_1_0,
            						"org.eclipse.xtext.common.Terminals.STRING");
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleImport"


    // $ANTLR start "entryRulePathAnnotation"
    // InternalMachine.g:256:1: entryRulePathAnnotation returns [EObject current=null] : iv_rulePathAnnotation= rulePathAnnotation EOF ;
    public final EObject entryRulePathAnnotation() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePathAnnotation = null;


        try {
            // InternalMachine.g:256:55: (iv_rulePathAnnotation= rulePathAnnotation EOF )
            // InternalMachine.g:257:2: iv_rulePathAnnotation= rulePathAnnotation EOF
            {
             newCompositeNode(grammarAccess.getPathAnnotationRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePathAnnotation=rulePathAnnotation();

            state._fsp--;

             current =iv_rulePathAnnotation; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePathAnnotation"


    // $ANTLR start "rulePathAnnotation"
    // InternalMachine.g:263:1: rulePathAnnotation returns [EObject current=null] : ( () ( (lv_name_1_0= RULE_ID ) ) ) ;
    public final EObject rulePathAnnotation() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;


        	enterRule();

        try {
            // InternalMachine.g:269:2: ( ( () ( (lv_name_1_0= RULE_ID ) ) ) )
            // InternalMachine.g:270:2: ( () ( (lv_name_1_0= RULE_ID ) ) )
            {
            // InternalMachine.g:270:2: ( () ( (lv_name_1_0= RULE_ID ) ) )
            // InternalMachine.g:271:3: () ( (lv_name_1_0= RULE_ID ) )
            {
            // InternalMachine.g:271:3: ()
            // InternalMachine.g:272:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getPathAnnotationAccess().getPathAnnotationAction_0(),
            					current);
            			

            }

            // InternalMachine.g:278:3: ( (lv_name_1_0= RULE_ID ) )
            // InternalMachine.g:279:4: (lv_name_1_0= RULE_ID )
            {
            // InternalMachine.g:279:4: (lv_name_1_0= RULE_ID )
            // InternalMachine.g:280:5: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_2); 

            					newLeafNode(lv_name_1_0, grammarAccess.getPathAnnotationAccess().getNameIDTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getPathAnnotationRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_1_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePathAnnotation"


    // $ANTLR start "entryRulePeripheralType"
    // InternalMachine.g:300:1: entryRulePeripheralType returns [EObject current=null] : iv_rulePeripheralType= rulePeripheralType EOF ;
    public final EObject entryRulePeripheralType() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePeripheralType = null;


        try {
            // InternalMachine.g:300:55: (iv_rulePeripheralType= rulePeripheralType EOF )
            // InternalMachine.g:301:2: iv_rulePeripheralType= rulePeripheralType EOF
            {
             newCompositeNode(grammarAccess.getPeripheralTypeRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePeripheralType=rulePeripheralType();

            state._fsp--;

             current =iv_rulePeripheralType; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePeripheralType"


    // $ANTLR start "rulePeripheralType"
    // InternalMachine.g:307:1: rulePeripheralType returns [EObject current=null] : ( () otherlv_1= 'PeripheralType' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= '{' (otherlv_4= 'Actions' otherlv_5= '{' ( (lv_actions_6_0= ruleActionType ) )* otherlv_7= '}' )? (otherlv_8= 'SetPoints' otherlv_9= '{' ( (lv_setPoints_10_0= ruleSetPoint ) )* otherlv_11= '}' otherlv_12= 'Axes' otherlv_13= '{' ( (lv_axes_14_0= ruleAxis ) )* otherlv_15= '}' (otherlv_16= 'Conversion' ( (lv_conversion_17_0= RULE_STRING ) ) )? )? otherlv_18= '}' ) ;
    public final EObject rulePeripheralType() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token lv_name_2_0=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_7=null;
        Token otherlv_8=null;
        Token otherlv_9=null;
        Token otherlv_11=null;
        Token otherlv_12=null;
        Token otherlv_13=null;
        Token otherlv_15=null;
        Token otherlv_16=null;
        Token lv_conversion_17_0=null;
        Token otherlv_18=null;
        EObject lv_actions_6_0 = null;

        EObject lv_setPoints_10_0 = null;

        EObject lv_axes_14_0 = null;



        	enterRule();

        try {
            // InternalMachine.g:313:2: ( ( () otherlv_1= 'PeripheralType' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= '{' (otherlv_4= 'Actions' otherlv_5= '{' ( (lv_actions_6_0= ruleActionType ) )* otherlv_7= '}' )? (otherlv_8= 'SetPoints' otherlv_9= '{' ( (lv_setPoints_10_0= ruleSetPoint ) )* otherlv_11= '}' otherlv_12= 'Axes' otherlv_13= '{' ( (lv_axes_14_0= ruleAxis ) )* otherlv_15= '}' (otherlv_16= 'Conversion' ( (lv_conversion_17_0= RULE_STRING ) ) )? )? otherlv_18= '}' ) )
            // InternalMachine.g:314:2: ( () otherlv_1= 'PeripheralType' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= '{' (otherlv_4= 'Actions' otherlv_5= '{' ( (lv_actions_6_0= ruleActionType ) )* otherlv_7= '}' )? (otherlv_8= 'SetPoints' otherlv_9= '{' ( (lv_setPoints_10_0= ruleSetPoint ) )* otherlv_11= '}' otherlv_12= 'Axes' otherlv_13= '{' ( (lv_axes_14_0= ruleAxis ) )* otherlv_15= '}' (otherlv_16= 'Conversion' ( (lv_conversion_17_0= RULE_STRING ) ) )? )? otherlv_18= '}' )
            {
            // InternalMachine.g:314:2: ( () otherlv_1= 'PeripheralType' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= '{' (otherlv_4= 'Actions' otherlv_5= '{' ( (lv_actions_6_0= ruleActionType ) )* otherlv_7= '}' )? (otherlv_8= 'SetPoints' otherlv_9= '{' ( (lv_setPoints_10_0= ruleSetPoint ) )* otherlv_11= '}' otherlv_12= 'Axes' otherlv_13= '{' ( (lv_axes_14_0= ruleAxis ) )* otherlv_15= '}' (otherlv_16= 'Conversion' ( (lv_conversion_17_0= RULE_STRING ) ) )? )? otherlv_18= '}' )
            // InternalMachine.g:315:3: () otherlv_1= 'PeripheralType' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= '{' (otherlv_4= 'Actions' otherlv_5= '{' ( (lv_actions_6_0= ruleActionType ) )* otherlv_7= '}' )? (otherlv_8= 'SetPoints' otherlv_9= '{' ( (lv_setPoints_10_0= ruleSetPoint ) )* otherlv_11= '}' otherlv_12= 'Axes' otherlv_13= '{' ( (lv_axes_14_0= ruleAxis ) )* otherlv_15= '}' (otherlv_16= 'Conversion' ( (lv_conversion_17_0= RULE_STRING ) ) )? )? otherlv_18= '}'
            {
            // InternalMachine.g:315:3: ()
            // InternalMachine.g:316:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getPeripheralTypeAccess().getPeripheralTypeAction_0(),
            					current);
            			

            }

            otherlv_1=(Token)match(input,16,FOLLOW_4); 

            			newLeafNode(otherlv_1, grammarAccess.getPeripheralTypeAccess().getPeripheralTypeKeyword_1());
            		
            // InternalMachine.g:326:3: ( (lv_name_2_0= RULE_ID ) )
            // InternalMachine.g:327:4: (lv_name_2_0= RULE_ID )
            {
            // InternalMachine.g:327:4: (lv_name_2_0= RULE_ID )
            // InternalMachine.g:328:5: lv_name_2_0= RULE_ID
            {
            lv_name_2_0=(Token)match(input,RULE_ID,FOLLOW_6); 

            					newLeafNode(lv_name_2_0, grammarAccess.getPeripheralTypeAccess().getNameIDTerminalRuleCall_2_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getPeripheralTypeRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_2_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }

            otherlv_3=(Token)match(input,13,FOLLOW_10); 

            			newLeafNode(otherlv_3, grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_3());
            		
            // InternalMachine.g:348:3: (otherlv_4= 'Actions' otherlv_5= '{' ( (lv_actions_6_0= ruleActionType ) )* otherlv_7= '}' )?
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==17) ) {
                alt7=1;
            }
            switch (alt7) {
                case 1 :
                    // InternalMachine.g:349:4: otherlv_4= 'Actions' otherlv_5= '{' ( (lv_actions_6_0= ruleActionType ) )* otherlv_7= '}'
                    {
                    otherlv_4=(Token)match(input,17,FOLLOW_6); 

                    				newLeafNode(otherlv_4, grammarAccess.getPeripheralTypeAccess().getActionsKeyword_4_0());
                    			
                    otherlv_5=(Token)match(input,13,FOLLOW_7); 

                    				newLeafNode(otherlv_5, grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_4_1());
                    			
                    // InternalMachine.g:357:4: ( (lv_actions_6_0= ruleActionType ) )*
                    loop6:
                    do {
                        int alt6=2;
                        int LA6_0 = input.LA(1);

                        if ( (LA6_0==RULE_ID) ) {
                            alt6=1;
                        }


                        switch (alt6) {
                    	case 1 :
                    	    // InternalMachine.g:358:5: (lv_actions_6_0= ruleActionType )
                    	    {
                    	    // InternalMachine.g:358:5: (lv_actions_6_0= ruleActionType )
                    	    // InternalMachine.g:359:6: lv_actions_6_0= ruleActionType
                    	    {

                    	    						newCompositeNode(grammarAccess.getPeripheralTypeAccess().getActionsActionTypeParserRuleCall_4_2_0());
                    	    					
                    	    pushFollow(FOLLOW_7);
                    	    lv_actions_6_0=ruleActionType();

                    	    state._fsp--;


                    	    						if (current==null) {
                    	    							current = createModelElementForParent(grammarAccess.getPeripheralTypeRule());
                    	    						}
                    	    						add(
                    	    							current,
                    	    							"actions",
                    	    							lv_actions_6_0,
                    	    							"org.eclipse.lsat.machine.teditor.Machine.ActionType");
                    	    						afterParserOrEnumRuleCall();
                    	    					

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop6;
                        }
                    } while (true);

                    otherlv_7=(Token)match(input,14,FOLLOW_11); 

                    				newLeafNode(otherlv_7, grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_4_3());
                    			

                    }
                    break;

            }

            // InternalMachine.g:381:3: (otherlv_8= 'SetPoints' otherlv_9= '{' ( (lv_setPoints_10_0= ruleSetPoint ) )* otherlv_11= '}' otherlv_12= 'Axes' otherlv_13= '{' ( (lv_axes_14_0= ruleAxis ) )* otherlv_15= '}' (otherlv_16= 'Conversion' ( (lv_conversion_17_0= RULE_STRING ) ) )? )?
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0==18) ) {
                alt11=1;
            }
            switch (alt11) {
                case 1 :
                    // InternalMachine.g:382:4: otherlv_8= 'SetPoints' otherlv_9= '{' ( (lv_setPoints_10_0= ruleSetPoint ) )* otherlv_11= '}' otherlv_12= 'Axes' otherlv_13= '{' ( (lv_axes_14_0= ruleAxis ) )* otherlv_15= '}' (otherlv_16= 'Conversion' ( (lv_conversion_17_0= RULE_STRING ) ) )?
                    {
                    otherlv_8=(Token)match(input,18,FOLLOW_6); 

                    				newLeafNode(otherlv_8, grammarAccess.getPeripheralTypeAccess().getSetPointsKeyword_5_0());
                    			
                    otherlv_9=(Token)match(input,13,FOLLOW_7); 

                    				newLeafNode(otherlv_9, grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_5_1());
                    			
                    // InternalMachine.g:390:4: ( (lv_setPoints_10_0= ruleSetPoint ) )*
                    loop8:
                    do {
                        int alt8=2;
                        int LA8_0 = input.LA(1);

                        if ( (LA8_0==RULE_ID) ) {
                            alt8=1;
                        }


                        switch (alt8) {
                    	case 1 :
                    	    // InternalMachine.g:391:5: (lv_setPoints_10_0= ruleSetPoint )
                    	    {
                    	    // InternalMachine.g:391:5: (lv_setPoints_10_0= ruleSetPoint )
                    	    // InternalMachine.g:392:6: lv_setPoints_10_0= ruleSetPoint
                    	    {

                    	    						newCompositeNode(grammarAccess.getPeripheralTypeAccess().getSetPointsSetPointParserRuleCall_5_2_0());
                    	    					
                    	    pushFollow(FOLLOW_7);
                    	    lv_setPoints_10_0=ruleSetPoint();

                    	    state._fsp--;


                    	    						if (current==null) {
                    	    							current = createModelElementForParent(grammarAccess.getPeripheralTypeRule());
                    	    						}
                    	    						add(
                    	    							current,
                    	    							"setPoints",
                    	    							lv_setPoints_10_0,
                    	    							"org.eclipse.lsat.machine.teditor.Machine.SetPoint");
                    	    						afterParserOrEnumRuleCall();
                    	    					

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop8;
                        }
                    } while (true);

                    otherlv_11=(Token)match(input,14,FOLLOW_12); 

                    				newLeafNode(otherlv_11, grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_5_3());
                    			
                    otherlv_12=(Token)match(input,19,FOLLOW_6); 

                    				newLeafNode(otherlv_12, grammarAccess.getPeripheralTypeAccess().getAxesKeyword_5_4());
                    			
                    otherlv_13=(Token)match(input,13,FOLLOW_7); 

                    				newLeafNode(otherlv_13, grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_5_5());
                    			
                    // InternalMachine.g:421:4: ( (lv_axes_14_0= ruleAxis ) )*
                    loop9:
                    do {
                        int alt9=2;
                        int LA9_0 = input.LA(1);

                        if ( (LA9_0==RULE_ID) ) {
                            alt9=1;
                        }


                        switch (alt9) {
                    	case 1 :
                    	    // InternalMachine.g:422:5: (lv_axes_14_0= ruleAxis )
                    	    {
                    	    // InternalMachine.g:422:5: (lv_axes_14_0= ruleAxis )
                    	    // InternalMachine.g:423:6: lv_axes_14_0= ruleAxis
                    	    {

                    	    						newCompositeNode(grammarAccess.getPeripheralTypeAccess().getAxesAxisParserRuleCall_5_6_0());
                    	    					
                    	    pushFollow(FOLLOW_7);
                    	    lv_axes_14_0=ruleAxis();

                    	    state._fsp--;


                    	    						if (current==null) {
                    	    							current = createModelElementForParent(grammarAccess.getPeripheralTypeRule());
                    	    						}
                    	    						add(
                    	    							current,
                    	    							"axes",
                    	    							lv_axes_14_0,
                    	    							"org.eclipse.lsat.machine.teditor.Machine.Axis");
                    	    						afterParserOrEnumRuleCall();
                    	    					

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop9;
                        }
                    } while (true);

                    otherlv_15=(Token)match(input,14,FOLLOW_13); 

                    				newLeafNode(otherlv_15, grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_5_7());
                    			
                    // InternalMachine.g:444:4: (otherlv_16= 'Conversion' ( (lv_conversion_17_0= RULE_STRING ) ) )?
                    int alt10=2;
                    int LA10_0 = input.LA(1);

                    if ( (LA10_0==20) ) {
                        alt10=1;
                    }
                    switch (alt10) {
                        case 1 :
                            // InternalMachine.g:445:5: otherlv_16= 'Conversion' ( (lv_conversion_17_0= RULE_STRING ) )
                            {
                            otherlv_16=(Token)match(input,20,FOLLOW_9); 

                            					newLeafNode(otherlv_16, grammarAccess.getPeripheralTypeAccess().getConversionKeyword_5_8_0());
                            				
                            // InternalMachine.g:449:5: ( (lv_conversion_17_0= RULE_STRING ) )
                            // InternalMachine.g:450:6: (lv_conversion_17_0= RULE_STRING )
                            {
                            // InternalMachine.g:450:6: (lv_conversion_17_0= RULE_STRING )
                            // InternalMachine.g:451:7: lv_conversion_17_0= RULE_STRING
                            {
                            lv_conversion_17_0=(Token)match(input,RULE_STRING,FOLLOW_14); 

                            							newLeafNode(lv_conversion_17_0, grammarAccess.getPeripheralTypeAccess().getConversionSTRINGTerminalRuleCall_5_8_1_0());
                            						

                            							if (current==null) {
                            								current = createModelElement(grammarAccess.getPeripheralTypeRule());
                            							}
                            							setWithLastConsumed(
                            								current,
                            								"conversion",
                            								lv_conversion_17_0,
                            								"org.eclipse.xtext.common.Terminals.STRING");
                            						

                            }


                            }


                            }
                            break;

                    }


                    }
                    break;

            }

            otherlv_18=(Token)match(input,14,FOLLOW_2); 

            			newLeafNode(otherlv_18, grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_6());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePeripheralType"


    // $ANTLR start "entryRuleActionType"
    // InternalMachine.g:477:1: entryRuleActionType returns [EObject current=null] : iv_ruleActionType= ruleActionType EOF ;
    public final EObject entryRuleActionType() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleActionType = null;


        try {
            // InternalMachine.g:477:51: (iv_ruleActionType= ruleActionType EOF )
            // InternalMachine.g:478:2: iv_ruleActionType= ruleActionType EOF
            {
             newCompositeNode(grammarAccess.getActionTypeRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleActionType=ruleActionType();

            state._fsp--;

             current =iv_ruleActionType; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleActionType"


    // $ANTLR start "ruleActionType"
    // InternalMachine.g:484:1: ruleActionType returns [EObject current=null] : ( () ( (lv_name_1_0= RULE_ID ) ) ) ;
    public final EObject ruleActionType() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;


        	enterRule();

        try {
            // InternalMachine.g:490:2: ( ( () ( (lv_name_1_0= RULE_ID ) ) ) )
            // InternalMachine.g:491:2: ( () ( (lv_name_1_0= RULE_ID ) ) )
            {
            // InternalMachine.g:491:2: ( () ( (lv_name_1_0= RULE_ID ) ) )
            // InternalMachine.g:492:3: () ( (lv_name_1_0= RULE_ID ) )
            {
            // InternalMachine.g:492:3: ()
            // InternalMachine.g:493:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getActionTypeAccess().getActionTypeAction_0(),
            					current);
            			

            }

            // InternalMachine.g:499:3: ( (lv_name_1_0= RULE_ID ) )
            // InternalMachine.g:500:4: (lv_name_1_0= RULE_ID )
            {
            // InternalMachine.g:500:4: (lv_name_1_0= RULE_ID )
            // InternalMachine.g:501:5: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_2); 

            					newLeafNode(lv_name_1_0, grammarAccess.getActionTypeAccess().getNameIDTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getActionTypeRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_1_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleActionType"


    // $ANTLR start "entryRuleSetPoint"
    // InternalMachine.g:521:1: entryRuleSetPoint returns [EObject current=null] : iv_ruleSetPoint= ruleSetPoint EOF ;
    public final EObject entryRuleSetPoint() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSetPoint = null;


        try {
            // InternalMachine.g:521:49: (iv_ruleSetPoint= ruleSetPoint EOF )
            // InternalMachine.g:522:2: iv_ruleSetPoint= ruleSetPoint EOF
            {
             newCompositeNode(grammarAccess.getSetPointRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleSetPoint=ruleSetPoint();

            state._fsp--;

             current =iv_ruleSetPoint; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSetPoint"


    // $ANTLR start "ruleSetPoint"
    // InternalMachine.g:528:1: ruleSetPoint returns [EObject current=null] : ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_unit_3_0= RULE_ID ) ) otherlv_4= ']' )? ) ;
    public final EObject ruleSetPoint() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token lv_unit_3_0=null;
        Token otherlv_4=null;


        	enterRule();

        try {
            // InternalMachine.g:534:2: ( ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_unit_3_0= RULE_ID ) ) otherlv_4= ']' )? ) )
            // InternalMachine.g:535:2: ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_unit_3_0= RULE_ID ) ) otherlv_4= ']' )? )
            {
            // InternalMachine.g:535:2: ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_unit_3_0= RULE_ID ) ) otherlv_4= ']' )? )
            // InternalMachine.g:536:3: () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_unit_3_0= RULE_ID ) ) otherlv_4= ']' )?
            {
            // InternalMachine.g:536:3: ()
            // InternalMachine.g:537:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getSetPointAccess().getSetPointAction_0(),
            					current);
            			

            }

            // InternalMachine.g:543:3: ( (lv_name_1_0= RULE_ID ) )
            // InternalMachine.g:544:4: (lv_name_1_0= RULE_ID )
            {
            // InternalMachine.g:544:4: (lv_name_1_0= RULE_ID )
            // InternalMachine.g:545:5: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_15); 

            					newLeafNode(lv_name_1_0, grammarAccess.getSetPointAccess().getNameIDTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getSetPointRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_1_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }

            // InternalMachine.g:561:3: (otherlv_2= '[' ( (lv_unit_3_0= RULE_ID ) ) otherlv_4= ']' )?
            int alt12=2;
            int LA12_0 = input.LA(1);

            if ( (LA12_0==21) ) {
                alt12=1;
            }
            switch (alt12) {
                case 1 :
                    // InternalMachine.g:562:4: otherlv_2= '[' ( (lv_unit_3_0= RULE_ID ) ) otherlv_4= ']'
                    {
                    otherlv_2=(Token)match(input,21,FOLLOW_4); 

                    				newLeafNode(otherlv_2, grammarAccess.getSetPointAccess().getLeftSquareBracketKeyword_2_0());
                    			
                    // InternalMachine.g:566:4: ( (lv_unit_3_0= RULE_ID ) )
                    // InternalMachine.g:567:5: (lv_unit_3_0= RULE_ID )
                    {
                    // InternalMachine.g:567:5: (lv_unit_3_0= RULE_ID )
                    // InternalMachine.g:568:6: lv_unit_3_0= RULE_ID
                    {
                    lv_unit_3_0=(Token)match(input,RULE_ID,FOLLOW_16); 

                    						newLeafNode(lv_unit_3_0, grammarAccess.getSetPointAccess().getUnitIDTerminalRuleCall_2_1_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getSetPointRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"unit",
                    							lv_unit_3_0,
                    							"org.eclipse.xtext.common.Terminals.ID");
                    					

                    }


                    }

                    otherlv_4=(Token)match(input,22,FOLLOW_2); 

                    				newLeafNode(otherlv_4, grammarAccess.getSetPointAccess().getRightSquareBracketKeyword_2_2());
                    			

                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSetPoint"


    // $ANTLR start "entryRuleAxis"
    // InternalMachine.g:593:1: entryRuleAxis returns [EObject current=null] : iv_ruleAxis= ruleAxis EOF ;
    public final EObject entryRuleAxis() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAxis = null;


        try {
            // InternalMachine.g:593:45: (iv_ruleAxis= ruleAxis EOF )
            // InternalMachine.g:594:2: iv_ruleAxis= ruleAxis EOF
            {
             newCompositeNode(grammarAccess.getAxisRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleAxis=ruleAxis();

            state._fsp--;

             current =iv_ruleAxis; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAxis"


    // $ANTLR start "ruleAxis"
    // InternalMachine.g:600:1: ruleAxis returns [EObject current=null] : ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_unit_3_0= RULE_ID ) ) otherlv_4= ']' )? (otherlv_5= 'moves' ( (otherlv_6= RULE_ID ) ) (otherlv_7= ',' ( (otherlv_8= RULE_ID ) ) )* )? ) ;
    public final EObject ruleAxis() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token lv_unit_3_0=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_8=null;


        	enterRule();

        try {
            // InternalMachine.g:606:2: ( ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_unit_3_0= RULE_ID ) ) otherlv_4= ']' )? (otherlv_5= 'moves' ( (otherlv_6= RULE_ID ) ) (otherlv_7= ',' ( (otherlv_8= RULE_ID ) ) )* )? ) )
            // InternalMachine.g:607:2: ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_unit_3_0= RULE_ID ) ) otherlv_4= ']' )? (otherlv_5= 'moves' ( (otherlv_6= RULE_ID ) ) (otherlv_7= ',' ( (otherlv_8= RULE_ID ) ) )* )? )
            {
            // InternalMachine.g:607:2: ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_unit_3_0= RULE_ID ) ) otherlv_4= ']' )? (otherlv_5= 'moves' ( (otherlv_6= RULE_ID ) ) (otherlv_7= ',' ( (otherlv_8= RULE_ID ) ) )* )? )
            // InternalMachine.g:608:3: () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_unit_3_0= RULE_ID ) ) otherlv_4= ']' )? (otherlv_5= 'moves' ( (otherlv_6= RULE_ID ) ) (otherlv_7= ',' ( (otherlv_8= RULE_ID ) ) )* )?
            {
            // InternalMachine.g:608:3: ()
            // InternalMachine.g:609:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getAxisAccess().getAxisAction_0(),
            					current);
            			

            }

            // InternalMachine.g:615:3: ( (lv_name_1_0= RULE_ID ) )
            // InternalMachine.g:616:4: (lv_name_1_0= RULE_ID )
            {
            // InternalMachine.g:616:4: (lv_name_1_0= RULE_ID )
            // InternalMachine.g:617:5: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_17); 

            					newLeafNode(lv_name_1_0, grammarAccess.getAxisAccess().getNameIDTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getAxisRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_1_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }

            // InternalMachine.g:633:3: (otherlv_2= '[' ( (lv_unit_3_0= RULE_ID ) ) otherlv_4= ']' )?
            int alt13=2;
            int LA13_0 = input.LA(1);

            if ( (LA13_0==21) ) {
                alt13=1;
            }
            switch (alt13) {
                case 1 :
                    // InternalMachine.g:634:4: otherlv_2= '[' ( (lv_unit_3_0= RULE_ID ) ) otherlv_4= ']'
                    {
                    otherlv_2=(Token)match(input,21,FOLLOW_4); 

                    				newLeafNode(otherlv_2, grammarAccess.getAxisAccess().getLeftSquareBracketKeyword_2_0());
                    			
                    // InternalMachine.g:638:4: ( (lv_unit_3_0= RULE_ID ) )
                    // InternalMachine.g:639:5: (lv_unit_3_0= RULE_ID )
                    {
                    // InternalMachine.g:639:5: (lv_unit_3_0= RULE_ID )
                    // InternalMachine.g:640:6: lv_unit_3_0= RULE_ID
                    {
                    lv_unit_3_0=(Token)match(input,RULE_ID,FOLLOW_16); 

                    						newLeafNode(lv_unit_3_0, grammarAccess.getAxisAccess().getUnitIDTerminalRuleCall_2_1_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getAxisRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"unit",
                    							lv_unit_3_0,
                    							"org.eclipse.xtext.common.Terminals.ID");
                    					

                    }


                    }

                    otherlv_4=(Token)match(input,22,FOLLOW_18); 

                    				newLeafNode(otherlv_4, grammarAccess.getAxisAccess().getRightSquareBracketKeyword_2_2());
                    			

                    }
                    break;

            }

            // InternalMachine.g:661:3: (otherlv_5= 'moves' ( (otherlv_6= RULE_ID ) ) (otherlv_7= ',' ( (otherlv_8= RULE_ID ) ) )* )?
            int alt15=2;
            int LA15_0 = input.LA(1);

            if ( (LA15_0==23) ) {
                alt15=1;
            }
            switch (alt15) {
                case 1 :
                    // InternalMachine.g:662:4: otherlv_5= 'moves' ( (otherlv_6= RULE_ID ) ) (otherlv_7= ',' ( (otherlv_8= RULE_ID ) ) )*
                    {
                    otherlv_5=(Token)match(input,23,FOLLOW_4); 

                    				newLeafNode(otherlv_5, grammarAccess.getAxisAccess().getMovesKeyword_3_0());
                    			
                    // InternalMachine.g:666:4: ( (otherlv_6= RULE_ID ) )
                    // InternalMachine.g:667:5: (otherlv_6= RULE_ID )
                    {
                    // InternalMachine.g:667:5: (otherlv_6= RULE_ID )
                    // InternalMachine.g:668:6: otherlv_6= RULE_ID
                    {

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getAxisRule());
                    						}
                    					
                    otherlv_6=(Token)match(input,RULE_ID,FOLLOW_19); 

                    						newLeafNode(otherlv_6, grammarAccess.getAxisAccess().getSetPointsSetPointCrossReference_3_1_0());
                    					

                    }


                    }

                    // InternalMachine.g:679:4: (otherlv_7= ',' ( (otherlv_8= RULE_ID ) ) )*
                    loop14:
                    do {
                        int alt14=2;
                        int LA14_0 = input.LA(1);

                        if ( (LA14_0==24) ) {
                            alt14=1;
                        }


                        switch (alt14) {
                    	case 1 :
                    	    // InternalMachine.g:680:5: otherlv_7= ',' ( (otherlv_8= RULE_ID ) )
                    	    {
                    	    otherlv_7=(Token)match(input,24,FOLLOW_4); 

                    	    					newLeafNode(otherlv_7, grammarAccess.getAxisAccess().getCommaKeyword_3_2_0());
                    	    				
                    	    // InternalMachine.g:684:5: ( (otherlv_8= RULE_ID ) )
                    	    // InternalMachine.g:685:6: (otherlv_8= RULE_ID )
                    	    {
                    	    // InternalMachine.g:685:6: (otherlv_8= RULE_ID )
                    	    // InternalMachine.g:686:7: otherlv_8= RULE_ID
                    	    {

                    	    							if (current==null) {
                    	    								current = createModelElement(grammarAccess.getAxisRule());
                    	    							}
                    	    						
                    	    otherlv_8=(Token)match(input,RULE_ID,FOLLOW_19); 

                    	    							newLeafNode(otherlv_8, grammarAccess.getAxisAccess().getSetPointsSetPointCrossReference_3_2_1_0());
                    	    						

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop14;
                        }
                    } while (true);


                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAxis"


    // $ANTLR start "entryRuleResourceItem"
    // InternalMachine.g:703:1: entryRuleResourceItem returns [EObject current=null] : iv_ruleResourceItem= ruleResourceItem EOF ;
    public final EObject entryRuleResourceItem() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleResourceItem = null;


        try {
            // InternalMachine.g:703:53: (iv_ruleResourceItem= ruleResourceItem EOF )
            // InternalMachine.g:704:2: iv_ruleResourceItem= ruleResourceItem EOF
            {
             newCompositeNode(grammarAccess.getResourceItemRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleResourceItem=ruleResourceItem();

            state._fsp--;

             current =iv_ruleResourceItem; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleResourceItem"


    // $ANTLR start "ruleResourceItem"
    // InternalMachine.g:710:1: ruleResourceItem returns [EObject current=null] : ( () ( (lv_name_1_0= ruleIID ) ) ) ;
    public final EObject ruleResourceItem() throws RecognitionException {
        EObject current = null;

        AntlrDatatypeRuleToken lv_name_1_0 = null;



        	enterRule();

        try {
            // InternalMachine.g:716:2: ( ( () ( (lv_name_1_0= ruleIID ) ) ) )
            // InternalMachine.g:717:2: ( () ( (lv_name_1_0= ruleIID ) ) )
            {
            // InternalMachine.g:717:2: ( () ( (lv_name_1_0= ruleIID ) ) )
            // InternalMachine.g:718:3: () ( (lv_name_1_0= ruleIID ) )
            {
            // InternalMachine.g:718:3: ()
            // InternalMachine.g:719:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getResourceItemAccess().getResourceItemAction_0(),
            					current);
            			

            }

            // InternalMachine.g:725:3: ( (lv_name_1_0= ruleIID ) )
            // InternalMachine.g:726:4: (lv_name_1_0= ruleIID )
            {
            // InternalMachine.g:726:4: (lv_name_1_0= ruleIID )
            // InternalMachine.g:727:5: lv_name_1_0= ruleIID
            {

            					newCompositeNode(grammarAccess.getResourceItemAccess().getNameIIDParserRuleCall_1_0());
            				
            pushFollow(FOLLOW_2);
            lv_name_1_0=ruleIID();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getResourceItemRule());
            					}
            					set(
            						current,
            						"name",
            						lv_name_1_0,
            						"org.eclipse.lsat.machine.teditor.Machine.IID");
            					afterParserOrEnumRuleCall();
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleResourceItem"


    // $ANTLR start "entryRuleResource"
    // InternalMachine.g:748:1: entryRuleResource returns [EObject current=null] : iv_ruleResource= ruleResource EOF ;
    public final EObject entryRuleResource() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleResource = null;


        try {
            // InternalMachine.g:748:49: (iv_ruleResource= ruleResource EOF )
            // InternalMachine.g:749:2: iv_ruleResource= ruleResource EOF
            {
             newCompositeNode(grammarAccess.getResourceRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleResource=ruleResource();

            state._fsp--;

             current =iv_ruleResource; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleResource"


    // $ANTLR start "ruleResource"
    // InternalMachine.g:755:1: ruleResource returns [EObject current=null] : (otherlv_0= 'Resource' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '(' ( (lv_items_3_0= ruleResourceItem ) ) (otherlv_4= ',' ( (lv_items_5_0= ruleResourceItem ) ) )* otherlv_6= ')' )? otherlv_7= '{' ( (lv_peripherals_8_0= rulePeripheral ) )* otherlv_9= '}' ) ;
    public final EObject ruleResource() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_9=null;
        EObject lv_items_3_0 = null;

        EObject lv_items_5_0 = null;

        EObject lv_peripherals_8_0 = null;



        	enterRule();

        try {
            // InternalMachine.g:761:2: ( (otherlv_0= 'Resource' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '(' ( (lv_items_3_0= ruleResourceItem ) ) (otherlv_4= ',' ( (lv_items_5_0= ruleResourceItem ) ) )* otherlv_6= ')' )? otherlv_7= '{' ( (lv_peripherals_8_0= rulePeripheral ) )* otherlv_9= '}' ) )
            // InternalMachine.g:762:2: (otherlv_0= 'Resource' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '(' ( (lv_items_3_0= ruleResourceItem ) ) (otherlv_4= ',' ( (lv_items_5_0= ruleResourceItem ) ) )* otherlv_6= ')' )? otherlv_7= '{' ( (lv_peripherals_8_0= rulePeripheral ) )* otherlv_9= '}' )
            {
            // InternalMachine.g:762:2: (otherlv_0= 'Resource' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '(' ( (lv_items_3_0= ruleResourceItem ) ) (otherlv_4= ',' ( (lv_items_5_0= ruleResourceItem ) ) )* otherlv_6= ')' )? otherlv_7= '{' ( (lv_peripherals_8_0= rulePeripheral ) )* otherlv_9= '}' )
            // InternalMachine.g:763:3: otherlv_0= 'Resource' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '(' ( (lv_items_3_0= ruleResourceItem ) ) (otherlv_4= ',' ( (lv_items_5_0= ruleResourceItem ) ) )* otherlv_6= ')' )? otherlv_7= '{' ( (lv_peripherals_8_0= rulePeripheral ) )* otherlv_9= '}'
            {
            otherlv_0=(Token)match(input,25,FOLLOW_4); 

            			newLeafNode(otherlv_0, grammarAccess.getResourceAccess().getResourceKeyword_0());
            		
            // InternalMachine.g:767:3: ( (lv_name_1_0= RULE_ID ) )
            // InternalMachine.g:768:4: (lv_name_1_0= RULE_ID )
            {
            // InternalMachine.g:768:4: (lv_name_1_0= RULE_ID )
            // InternalMachine.g:769:5: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_20); 

            					newLeafNode(lv_name_1_0, grammarAccess.getResourceAccess().getNameIDTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getResourceRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_1_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }

            // InternalMachine.g:785:3: (otherlv_2= '(' ( (lv_items_3_0= ruleResourceItem ) ) (otherlv_4= ',' ( (lv_items_5_0= ruleResourceItem ) ) )* otherlv_6= ')' )?
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( (LA17_0==26) ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // InternalMachine.g:786:4: otherlv_2= '(' ( (lv_items_3_0= ruleResourceItem ) ) (otherlv_4= ',' ( (lv_items_5_0= ruleResourceItem ) ) )* otherlv_6= ')'
                    {
                    otherlv_2=(Token)match(input,26,FOLLOW_21); 

                    				newLeafNode(otherlv_2, grammarAccess.getResourceAccess().getLeftParenthesisKeyword_2_0());
                    			
                    // InternalMachine.g:790:4: ( (lv_items_3_0= ruleResourceItem ) )
                    // InternalMachine.g:791:5: (lv_items_3_0= ruleResourceItem )
                    {
                    // InternalMachine.g:791:5: (lv_items_3_0= ruleResourceItem )
                    // InternalMachine.g:792:6: lv_items_3_0= ruleResourceItem
                    {

                    						newCompositeNode(grammarAccess.getResourceAccess().getItemsResourceItemParserRuleCall_2_1_0());
                    					
                    pushFollow(FOLLOW_22);
                    lv_items_3_0=ruleResourceItem();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getResourceRule());
                    						}
                    						add(
                    							current,
                    							"items",
                    							lv_items_3_0,
                    							"org.eclipse.lsat.machine.teditor.Machine.ResourceItem");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    // InternalMachine.g:809:4: (otherlv_4= ',' ( (lv_items_5_0= ruleResourceItem ) ) )*
                    loop16:
                    do {
                        int alt16=2;
                        int LA16_0 = input.LA(1);

                        if ( (LA16_0==24) ) {
                            alt16=1;
                        }


                        switch (alt16) {
                    	case 1 :
                    	    // InternalMachine.g:810:5: otherlv_4= ',' ( (lv_items_5_0= ruleResourceItem ) )
                    	    {
                    	    otherlv_4=(Token)match(input,24,FOLLOW_21); 

                    	    					newLeafNode(otherlv_4, grammarAccess.getResourceAccess().getCommaKeyword_2_2_0());
                    	    				
                    	    // InternalMachine.g:814:5: ( (lv_items_5_0= ruleResourceItem ) )
                    	    // InternalMachine.g:815:6: (lv_items_5_0= ruleResourceItem )
                    	    {
                    	    // InternalMachine.g:815:6: (lv_items_5_0= ruleResourceItem )
                    	    // InternalMachine.g:816:7: lv_items_5_0= ruleResourceItem
                    	    {

                    	    							newCompositeNode(grammarAccess.getResourceAccess().getItemsResourceItemParserRuleCall_2_2_1_0());
                    	    						
                    	    pushFollow(FOLLOW_22);
                    	    lv_items_5_0=ruleResourceItem();

                    	    state._fsp--;


                    	    							if (current==null) {
                    	    								current = createModelElementForParent(grammarAccess.getResourceRule());
                    	    							}
                    	    							add(
                    	    								current,
                    	    								"items",
                    	    								lv_items_5_0,
                    	    								"org.eclipse.lsat.machine.teditor.Machine.ResourceItem");
                    	    							afterParserOrEnumRuleCall();
                    	    						

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop16;
                        }
                    } while (true);

                    otherlv_6=(Token)match(input,27,FOLLOW_6); 

                    				newLeafNode(otherlv_6, grammarAccess.getResourceAccess().getRightParenthesisKeyword_2_3());
                    			

                    }
                    break;

            }

            otherlv_7=(Token)match(input,13,FOLLOW_7); 

            			newLeafNode(otherlv_7, grammarAccess.getResourceAccess().getLeftCurlyBracketKeyword_3());
            		
            // InternalMachine.g:843:3: ( (lv_peripherals_8_0= rulePeripheral ) )*
            loop18:
            do {
                int alt18=2;
                int LA18_0 = input.LA(1);

                if ( (LA18_0==RULE_ID) ) {
                    alt18=1;
                }


                switch (alt18) {
            	case 1 :
            	    // InternalMachine.g:844:4: (lv_peripherals_8_0= rulePeripheral )
            	    {
            	    // InternalMachine.g:844:4: (lv_peripherals_8_0= rulePeripheral )
            	    // InternalMachine.g:845:5: lv_peripherals_8_0= rulePeripheral
            	    {

            	    					newCompositeNode(grammarAccess.getResourceAccess().getPeripheralsPeripheralParserRuleCall_4_0());
            	    				
            	    pushFollow(FOLLOW_7);
            	    lv_peripherals_8_0=rulePeripheral();

            	    state._fsp--;


            	    					if (current==null) {
            	    						current = createModelElementForParent(grammarAccess.getResourceRule());
            	    					}
            	    					add(
            	    						current,
            	    						"peripherals",
            	    						lv_peripherals_8_0,
            	    						"org.eclipse.lsat.machine.teditor.Machine.Peripheral");
            	    					afterParserOrEnumRuleCall();
            	    				

            	    }


            	    }
            	    break;

            	default :
            	    break loop18;
                }
            } while (true);

            otherlv_9=(Token)match(input,14,FOLLOW_2); 

            			newLeafNode(otherlv_9, grammarAccess.getResourceAccess().getRightCurlyBracketKeyword_5());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleResource"


    // $ANTLR start "entryRulePeripheral"
    // InternalMachine.g:870:1: entryRulePeripheral returns [EObject current=null] : iv_rulePeripheral= rulePeripheral EOF ;
    public final EObject entryRulePeripheral() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePeripheral = null;


        try {
            // InternalMachine.g:870:51: (iv_rulePeripheral= rulePeripheral EOF )
            // InternalMachine.g:871:2: iv_rulePeripheral= rulePeripheral EOF
            {
             newCompositeNode(grammarAccess.getPeripheralRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePeripheral=rulePeripheral();

            state._fsp--;

             current =iv_rulePeripheral; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePeripheral"


    // $ANTLR start "rulePeripheral"
    // InternalMachine.g:877:1: rulePeripheral returns [EObject current=null] : ( ( (lv_name_0_0= RULE_ID ) ) otherlv_1= ':' ( (otherlv_2= RULE_ID ) ) (otherlv_3= '{' ( (otherlv_4= 'AxisPositions' otherlv_5= '{' ( (lv_axisPositions_6_0= ruleAxisPositionsMapEntry ) )* otherlv_7= '}' )? (otherlv_8= 'SymbolicPositions' otherlv_9= '{' ( (lv_positions_10_0= ruleSymbolicPosition ) )* otherlv_11= '}' )? otherlv_12= 'Profiles' otherlv_13= '(' ( (lv_profiles_14_0= ruleProfile ) ) (otherlv_15= ',' ( (lv_profiles_16_0= ruleProfile ) ) )* otherlv_17= ')' (otherlv_18= 'Distances' otherlv_19= '{' ( (lv_distances_20_0= ruleDistance ) )* otherlv_21= '}' )? (otherlv_22= 'Paths' otherlv_23= '{' ( (lv_paths_24_0= rulePath ) )* otherlv_25= '}' )? )? otherlv_26= '}' )? ) ;
    public final EObject rulePeripheral() throws RecognitionException {
        EObject current = null;

        Token lv_name_0_0=null;
        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_7=null;
        Token otherlv_8=null;
        Token otherlv_9=null;
        Token otherlv_11=null;
        Token otherlv_12=null;
        Token otherlv_13=null;
        Token otherlv_15=null;
        Token otherlv_17=null;
        Token otherlv_18=null;
        Token otherlv_19=null;
        Token otherlv_21=null;
        Token otherlv_22=null;
        Token otherlv_23=null;
        Token otherlv_25=null;
        Token otherlv_26=null;
        EObject lv_axisPositions_6_0 = null;

        EObject lv_positions_10_0 = null;

        EObject lv_profiles_14_0 = null;

        EObject lv_profiles_16_0 = null;

        EObject lv_distances_20_0 = null;

        EObject lv_paths_24_0 = null;



        	enterRule();

        try {
            // InternalMachine.g:883:2: ( ( ( (lv_name_0_0= RULE_ID ) ) otherlv_1= ':' ( (otherlv_2= RULE_ID ) ) (otherlv_3= '{' ( (otherlv_4= 'AxisPositions' otherlv_5= '{' ( (lv_axisPositions_6_0= ruleAxisPositionsMapEntry ) )* otherlv_7= '}' )? (otherlv_8= 'SymbolicPositions' otherlv_9= '{' ( (lv_positions_10_0= ruleSymbolicPosition ) )* otherlv_11= '}' )? otherlv_12= 'Profiles' otherlv_13= '(' ( (lv_profiles_14_0= ruleProfile ) ) (otherlv_15= ',' ( (lv_profiles_16_0= ruleProfile ) ) )* otherlv_17= ')' (otherlv_18= 'Distances' otherlv_19= '{' ( (lv_distances_20_0= ruleDistance ) )* otherlv_21= '}' )? (otherlv_22= 'Paths' otherlv_23= '{' ( (lv_paths_24_0= rulePath ) )* otherlv_25= '}' )? )? otherlv_26= '}' )? ) )
            // InternalMachine.g:884:2: ( ( (lv_name_0_0= RULE_ID ) ) otherlv_1= ':' ( (otherlv_2= RULE_ID ) ) (otherlv_3= '{' ( (otherlv_4= 'AxisPositions' otherlv_5= '{' ( (lv_axisPositions_6_0= ruleAxisPositionsMapEntry ) )* otherlv_7= '}' )? (otherlv_8= 'SymbolicPositions' otherlv_9= '{' ( (lv_positions_10_0= ruleSymbolicPosition ) )* otherlv_11= '}' )? otherlv_12= 'Profiles' otherlv_13= '(' ( (lv_profiles_14_0= ruleProfile ) ) (otherlv_15= ',' ( (lv_profiles_16_0= ruleProfile ) ) )* otherlv_17= ')' (otherlv_18= 'Distances' otherlv_19= '{' ( (lv_distances_20_0= ruleDistance ) )* otherlv_21= '}' )? (otherlv_22= 'Paths' otherlv_23= '{' ( (lv_paths_24_0= rulePath ) )* otherlv_25= '}' )? )? otherlv_26= '}' )? )
            {
            // InternalMachine.g:884:2: ( ( (lv_name_0_0= RULE_ID ) ) otherlv_1= ':' ( (otherlv_2= RULE_ID ) ) (otherlv_3= '{' ( (otherlv_4= 'AxisPositions' otherlv_5= '{' ( (lv_axisPositions_6_0= ruleAxisPositionsMapEntry ) )* otherlv_7= '}' )? (otherlv_8= 'SymbolicPositions' otherlv_9= '{' ( (lv_positions_10_0= ruleSymbolicPosition ) )* otherlv_11= '}' )? otherlv_12= 'Profiles' otherlv_13= '(' ( (lv_profiles_14_0= ruleProfile ) ) (otherlv_15= ',' ( (lv_profiles_16_0= ruleProfile ) ) )* otherlv_17= ')' (otherlv_18= 'Distances' otherlv_19= '{' ( (lv_distances_20_0= ruleDistance ) )* otherlv_21= '}' )? (otherlv_22= 'Paths' otherlv_23= '{' ( (lv_paths_24_0= rulePath ) )* otherlv_25= '}' )? )? otherlv_26= '}' )? )
            // InternalMachine.g:885:3: ( (lv_name_0_0= RULE_ID ) ) otherlv_1= ':' ( (otherlv_2= RULE_ID ) ) (otherlv_3= '{' ( (otherlv_4= 'AxisPositions' otherlv_5= '{' ( (lv_axisPositions_6_0= ruleAxisPositionsMapEntry ) )* otherlv_7= '}' )? (otherlv_8= 'SymbolicPositions' otherlv_9= '{' ( (lv_positions_10_0= ruleSymbolicPosition ) )* otherlv_11= '}' )? otherlv_12= 'Profiles' otherlv_13= '(' ( (lv_profiles_14_0= ruleProfile ) ) (otherlv_15= ',' ( (lv_profiles_16_0= ruleProfile ) ) )* otherlv_17= ')' (otherlv_18= 'Distances' otherlv_19= '{' ( (lv_distances_20_0= ruleDistance ) )* otherlv_21= '}' )? (otherlv_22= 'Paths' otherlv_23= '{' ( (lv_paths_24_0= rulePath ) )* otherlv_25= '}' )? )? otherlv_26= '}' )?
            {
            // InternalMachine.g:885:3: ( (lv_name_0_0= RULE_ID ) )
            // InternalMachine.g:886:4: (lv_name_0_0= RULE_ID )
            {
            // InternalMachine.g:886:4: (lv_name_0_0= RULE_ID )
            // InternalMachine.g:887:5: lv_name_0_0= RULE_ID
            {
            lv_name_0_0=(Token)match(input,RULE_ID,FOLLOW_23); 

            					newLeafNode(lv_name_0_0, grammarAccess.getPeripheralAccess().getNameIDTerminalRuleCall_0_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getPeripheralRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_0_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }

            otherlv_1=(Token)match(input,28,FOLLOW_4); 

            			newLeafNode(otherlv_1, grammarAccess.getPeripheralAccess().getColonKeyword_1());
            		
            // InternalMachine.g:907:3: ( (otherlv_2= RULE_ID ) )
            // InternalMachine.g:908:4: (otherlv_2= RULE_ID )
            {
            // InternalMachine.g:908:4: (otherlv_2= RULE_ID )
            // InternalMachine.g:909:5: otherlv_2= RULE_ID
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getPeripheralRule());
            					}
            				
            otherlv_2=(Token)match(input,RULE_ID,FOLLOW_24); 

            					newLeafNode(otherlv_2, grammarAccess.getPeripheralAccess().getTypePeripheralTypeCrossReference_2_0());
            				

            }


            }

            // InternalMachine.g:920:3: (otherlv_3= '{' ( (otherlv_4= 'AxisPositions' otherlv_5= '{' ( (lv_axisPositions_6_0= ruleAxisPositionsMapEntry ) )* otherlv_7= '}' )? (otherlv_8= 'SymbolicPositions' otherlv_9= '{' ( (lv_positions_10_0= ruleSymbolicPosition ) )* otherlv_11= '}' )? otherlv_12= 'Profiles' otherlv_13= '(' ( (lv_profiles_14_0= ruleProfile ) ) (otherlv_15= ',' ( (lv_profiles_16_0= ruleProfile ) ) )* otherlv_17= ')' (otherlv_18= 'Distances' otherlv_19= '{' ( (lv_distances_20_0= ruleDistance ) )* otherlv_21= '}' )? (otherlv_22= 'Paths' otherlv_23= '{' ( (lv_paths_24_0= rulePath ) )* otherlv_25= '}' )? )? otherlv_26= '}' )?
            int alt29=2;
            int LA29_0 = input.LA(1);

            if ( (LA29_0==13) ) {
                alt29=1;
            }
            switch (alt29) {
                case 1 :
                    // InternalMachine.g:921:4: otherlv_3= '{' ( (otherlv_4= 'AxisPositions' otherlv_5= '{' ( (lv_axisPositions_6_0= ruleAxisPositionsMapEntry ) )* otherlv_7= '}' )? (otherlv_8= 'SymbolicPositions' otherlv_9= '{' ( (lv_positions_10_0= ruleSymbolicPosition ) )* otherlv_11= '}' )? otherlv_12= 'Profiles' otherlv_13= '(' ( (lv_profiles_14_0= ruleProfile ) ) (otherlv_15= ',' ( (lv_profiles_16_0= ruleProfile ) ) )* otherlv_17= ')' (otherlv_18= 'Distances' otherlv_19= '{' ( (lv_distances_20_0= ruleDistance ) )* otherlv_21= '}' )? (otherlv_22= 'Paths' otherlv_23= '{' ( (lv_paths_24_0= rulePath ) )* otherlv_25= '}' )? )? otherlv_26= '}'
                    {
                    otherlv_3=(Token)match(input,13,FOLLOW_25); 

                    				newLeafNode(otherlv_3, grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_0());
                    			
                    // InternalMachine.g:925:4: ( (otherlv_4= 'AxisPositions' otherlv_5= '{' ( (lv_axisPositions_6_0= ruleAxisPositionsMapEntry ) )* otherlv_7= '}' )? (otherlv_8= 'SymbolicPositions' otherlv_9= '{' ( (lv_positions_10_0= ruleSymbolicPosition ) )* otherlv_11= '}' )? otherlv_12= 'Profiles' otherlv_13= '(' ( (lv_profiles_14_0= ruleProfile ) ) (otherlv_15= ',' ( (lv_profiles_16_0= ruleProfile ) ) )* otherlv_17= ')' (otherlv_18= 'Distances' otherlv_19= '{' ( (lv_distances_20_0= ruleDistance ) )* otherlv_21= '}' )? (otherlv_22= 'Paths' otherlv_23= '{' ( (lv_paths_24_0= rulePath ) )* otherlv_25= '}' )? )?
                    int alt28=2;
                    int LA28_0 = input.LA(1);

                    if ( ((LA28_0>=29 && LA28_0<=31)) ) {
                        alt28=1;
                    }
                    switch (alt28) {
                        case 1 :
                            // InternalMachine.g:926:5: (otherlv_4= 'AxisPositions' otherlv_5= '{' ( (lv_axisPositions_6_0= ruleAxisPositionsMapEntry ) )* otherlv_7= '}' )? (otherlv_8= 'SymbolicPositions' otherlv_9= '{' ( (lv_positions_10_0= ruleSymbolicPosition ) )* otherlv_11= '}' )? otherlv_12= 'Profiles' otherlv_13= '(' ( (lv_profiles_14_0= ruleProfile ) ) (otherlv_15= ',' ( (lv_profiles_16_0= ruleProfile ) ) )* otherlv_17= ')' (otherlv_18= 'Distances' otherlv_19= '{' ( (lv_distances_20_0= ruleDistance ) )* otherlv_21= '}' )? (otherlv_22= 'Paths' otherlv_23= '{' ( (lv_paths_24_0= rulePath ) )* otherlv_25= '}' )?
                            {
                            // InternalMachine.g:926:5: (otherlv_4= 'AxisPositions' otherlv_5= '{' ( (lv_axisPositions_6_0= ruleAxisPositionsMapEntry ) )* otherlv_7= '}' )?
                            int alt20=2;
                            int LA20_0 = input.LA(1);

                            if ( (LA20_0==29) ) {
                                alt20=1;
                            }
                            switch (alt20) {
                                case 1 :
                                    // InternalMachine.g:927:6: otherlv_4= 'AxisPositions' otherlv_5= '{' ( (lv_axisPositions_6_0= ruleAxisPositionsMapEntry ) )* otherlv_7= '}'
                                    {
                                    otherlv_4=(Token)match(input,29,FOLLOW_6); 

                                    						newLeafNode(otherlv_4, grammarAccess.getPeripheralAccess().getAxisPositionsKeyword_3_1_0_0());
                                    					
                                    otherlv_5=(Token)match(input,13,FOLLOW_7); 

                                    						newLeafNode(otherlv_5, grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_0_1());
                                    					
                                    // InternalMachine.g:935:6: ( (lv_axisPositions_6_0= ruleAxisPositionsMapEntry ) )*
                                    loop19:
                                    do {
                                        int alt19=2;
                                        int LA19_0 = input.LA(1);

                                        if ( (LA19_0==RULE_ID) ) {
                                            alt19=1;
                                        }


                                        switch (alt19) {
                                    	case 1 :
                                    	    // InternalMachine.g:936:7: (lv_axisPositions_6_0= ruleAxisPositionsMapEntry )
                                    	    {
                                    	    // InternalMachine.g:936:7: (lv_axisPositions_6_0= ruleAxisPositionsMapEntry )
                                    	    // InternalMachine.g:937:8: lv_axisPositions_6_0= ruleAxisPositionsMapEntry
                                    	    {

                                    	    								newCompositeNode(grammarAccess.getPeripheralAccess().getAxisPositionsAxisPositionsMapEntryParserRuleCall_3_1_0_2_0());
                                    	    							
                                    	    pushFollow(FOLLOW_7);
                                    	    lv_axisPositions_6_0=ruleAxisPositionsMapEntry();

                                    	    state._fsp--;


                                    	    								if (current==null) {
                                    	    									current = createModelElementForParent(grammarAccess.getPeripheralRule());
                                    	    								}
                                    	    								add(
                                    	    									current,
                                    	    									"axisPositions",
                                    	    									lv_axisPositions_6_0,
                                    	    									"org.eclipse.lsat.machine.teditor.Machine.AxisPositionsMapEntry");
                                    	    								afterParserOrEnumRuleCall();
                                    	    							

                                    	    }


                                    	    }
                                    	    break;

                                    	default :
                                    	    break loop19;
                                        }
                                    } while (true);

                                    otherlv_7=(Token)match(input,14,FOLLOW_26); 

                                    						newLeafNode(otherlv_7, grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_0_3());
                                    					

                                    }
                                    break;

                            }

                            // InternalMachine.g:959:5: (otherlv_8= 'SymbolicPositions' otherlv_9= '{' ( (lv_positions_10_0= ruleSymbolicPosition ) )* otherlv_11= '}' )?
                            int alt22=2;
                            int LA22_0 = input.LA(1);

                            if ( (LA22_0==30) ) {
                                alt22=1;
                            }
                            switch (alt22) {
                                case 1 :
                                    // InternalMachine.g:960:6: otherlv_8= 'SymbolicPositions' otherlv_9= '{' ( (lv_positions_10_0= ruleSymbolicPosition ) )* otherlv_11= '}'
                                    {
                                    otherlv_8=(Token)match(input,30,FOLLOW_6); 

                                    						newLeafNode(otherlv_8, grammarAccess.getPeripheralAccess().getSymbolicPositionsKeyword_3_1_1_0());
                                    					
                                    otherlv_9=(Token)match(input,13,FOLLOW_7); 

                                    						newLeafNode(otherlv_9, grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_1_1());
                                    					
                                    // InternalMachine.g:968:6: ( (lv_positions_10_0= ruleSymbolicPosition ) )*
                                    loop21:
                                    do {
                                        int alt21=2;
                                        int LA21_0 = input.LA(1);

                                        if ( (LA21_0==RULE_ID) ) {
                                            alt21=1;
                                        }


                                        switch (alt21) {
                                    	case 1 :
                                    	    // InternalMachine.g:969:7: (lv_positions_10_0= ruleSymbolicPosition )
                                    	    {
                                    	    // InternalMachine.g:969:7: (lv_positions_10_0= ruleSymbolicPosition )
                                    	    // InternalMachine.g:970:8: lv_positions_10_0= ruleSymbolicPosition
                                    	    {

                                    	    								newCompositeNode(grammarAccess.getPeripheralAccess().getPositionsSymbolicPositionParserRuleCall_3_1_1_2_0());
                                    	    							
                                    	    pushFollow(FOLLOW_7);
                                    	    lv_positions_10_0=ruleSymbolicPosition();

                                    	    state._fsp--;


                                    	    								if (current==null) {
                                    	    									current = createModelElementForParent(grammarAccess.getPeripheralRule());
                                    	    								}
                                    	    								add(
                                    	    									current,
                                    	    									"positions",
                                    	    									lv_positions_10_0,
                                    	    									"org.eclipse.lsat.machine.teditor.Machine.SymbolicPosition");
                                    	    								afterParserOrEnumRuleCall();
                                    	    							

                                    	    }


                                    	    }
                                    	    break;

                                    	default :
                                    	    break loop21;
                                        }
                                    } while (true);

                                    otherlv_11=(Token)match(input,14,FOLLOW_27); 

                                    						newLeafNode(otherlv_11, grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_1_3());
                                    					

                                    }
                                    break;

                            }

                            otherlv_12=(Token)match(input,31,FOLLOW_28); 

                            					newLeafNode(otherlv_12, grammarAccess.getPeripheralAccess().getProfilesKeyword_3_1_2());
                            				
                            otherlv_13=(Token)match(input,26,FOLLOW_4); 

                            					newLeafNode(otherlv_13, grammarAccess.getPeripheralAccess().getLeftParenthesisKeyword_3_1_3());
                            				
                            // InternalMachine.g:1000:5: ( (lv_profiles_14_0= ruleProfile ) )
                            // InternalMachine.g:1001:6: (lv_profiles_14_0= ruleProfile )
                            {
                            // InternalMachine.g:1001:6: (lv_profiles_14_0= ruleProfile )
                            // InternalMachine.g:1002:7: lv_profiles_14_0= ruleProfile
                            {

                            							newCompositeNode(grammarAccess.getPeripheralAccess().getProfilesProfileParserRuleCall_3_1_4_0());
                            						
                            pushFollow(FOLLOW_22);
                            lv_profiles_14_0=ruleProfile();

                            state._fsp--;


                            							if (current==null) {
                            								current = createModelElementForParent(grammarAccess.getPeripheralRule());
                            							}
                            							add(
                            								current,
                            								"profiles",
                            								lv_profiles_14_0,
                            								"org.eclipse.lsat.machine.teditor.Machine.Profile");
                            							afterParserOrEnumRuleCall();
                            						

                            }


                            }

                            // InternalMachine.g:1019:5: (otherlv_15= ',' ( (lv_profiles_16_0= ruleProfile ) ) )*
                            loop23:
                            do {
                                int alt23=2;
                                int LA23_0 = input.LA(1);

                                if ( (LA23_0==24) ) {
                                    alt23=1;
                                }


                                switch (alt23) {
                            	case 1 :
                            	    // InternalMachine.g:1020:6: otherlv_15= ',' ( (lv_profiles_16_0= ruleProfile ) )
                            	    {
                            	    otherlv_15=(Token)match(input,24,FOLLOW_4); 

                            	    						newLeafNode(otherlv_15, grammarAccess.getPeripheralAccess().getCommaKeyword_3_1_5_0());
                            	    					
                            	    // InternalMachine.g:1024:6: ( (lv_profiles_16_0= ruleProfile ) )
                            	    // InternalMachine.g:1025:7: (lv_profiles_16_0= ruleProfile )
                            	    {
                            	    // InternalMachine.g:1025:7: (lv_profiles_16_0= ruleProfile )
                            	    // InternalMachine.g:1026:8: lv_profiles_16_0= ruleProfile
                            	    {

                            	    								newCompositeNode(grammarAccess.getPeripheralAccess().getProfilesProfileParserRuleCall_3_1_5_1_0());
                            	    							
                            	    pushFollow(FOLLOW_22);
                            	    lv_profiles_16_0=ruleProfile();

                            	    state._fsp--;


                            	    								if (current==null) {
                            	    									current = createModelElementForParent(grammarAccess.getPeripheralRule());
                            	    								}
                            	    								add(
                            	    									current,
                            	    									"profiles",
                            	    									lv_profiles_16_0,
                            	    									"org.eclipse.lsat.machine.teditor.Machine.Profile");
                            	    								afterParserOrEnumRuleCall();
                            	    							

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop23;
                                }
                            } while (true);

                            otherlv_17=(Token)match(input,27,FOLLOW_29); 

                            					newLeafNode(otherlv_17, grammarAccess.getPeripheralAccess().getRightParenthesisKeyword_3_1_6());
                            				
                            // InternalMachine.g:1048:5: (otherlv_18= 'Distances' otherlv_19= '{' ( (lv_distances_20_0= ruleDistance ) )* otherlv_21= '}' )?
                            int alt25=2;
                            int LA25_0 = input.LA(1);

                            if ( (LA25_0==32) ) {
                                alt25=1;
                            }
                            switch (alt25) {
                                case 1 :
                                    // InternalMachine.g:1049:6: otherlv_18= 'Distances' otherlv_19= '{' ( (lv_distances_20_0= ruleDistance ) )* otherlv_21= '}'
                                    {
                                    otherlv_18=(Token)match(input,32,FOLLOW_6); 

                                    						newLeafNode(otherlv_18, grammarAccess.getPeripheralAccess().getDistancesKeyword_3_1_7_0());
                                    					
                                    otherlv_19=(Token)match(input,13,FOLLOW_7); 

                                    						newLeafNode(otherlv_19, grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_7_1());
                                    					
                                    // InternalMachine.g:1057:6: ( (lv_distances_20_0= ruleDistance ) )*
                                    loop24:
                                    do {
                                        int alt24=2;
                                        int LA24_0 = input.LA(1);

                                        if ( (LA24_0==RULE_ID) ) {
                                            alt24=1;
                                        }


                                        switch (alt24) {
                                    	case 1 :
                                    	    // InternalMachine.g:1058:7: (lv_distances_20_0= ruleDistance )
                                    	    {
                                    	    // InternalMachine.g:1058:7: (lv_distances_20_0= ruleDistance )
                                    	    // InternalMachine.g:1059:8: lv_distances_20_0= ruleDistance
                                    	    {

                                    	    								newCompositeNode(grammarAccess.getPeripheralAccess().getDistancesDistanceParserRuleCall_3_1_7_2_0());
                                    	    							
                                    	    pushFollow(FOLLOW_7);
                                    	    lv_distances_20_0=ruleDistance();

                                    	    state._fsp--;


                                    	    								if (current==null) {
                                    	    									current = createModelElementForParent(grammarAccess.getPeripheralRule());
                                    	    								}
                                    	    								add(
                                    	    									current,
                                    	    									"distances",
                                    	    									lv_distances_20_0,
                                    	    									"org.eclipse.lsat.machine.teditor.Machine.Distance");
                                    	    								afterParserOrEnumRuleCall();
                                    	    							

                                    	    }


                                    	    }
                                    	    break;

                                    	default :
                                    	    break loop24;
                                        }
                                    } while (true);

                                    otherlv_21=(Token)match(input,14,FOLLOW_30); 

                                    						newLeafNode(otherlv_21, grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_7_3());
                                    					

                                    }
                                    break;

                            }

                            // InternalMachine.g:1081:5: (otherlv_22= 'Paths' otherlv_23= '{' ( (lv_paths_24_0= rulePath ) )* otherlv_25= '}' )?
                            int alt27=2;
                            int LA27_0 = input.LA(1);

                            if ( (LA27_0==33) ) {
                                alt27=1;
                            }
                            switch (alt27) {
                                case 1 :
                                    // InternalMachine.g:1082:6: otherlv_22= 'Paths' otherlv_23= '{' ( (lv_paths_24_0= rulePath ) )* otherlv_25= '}'
                                    {
                                    otherlv_22=(Token)match(input,33,FOLLOW_6); 

                                    						newLeafNode(otherlv_22, grammarAccess.getPeripheralAccess().getPathsKeyword_3_1_8_0());
                                    					
                                    otherlv_23=(Token)match(input,13,FOLLOW_31); 

                                    						newLeafNode(otherlv_23, grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_8_1());
                                    					
                                    // InternalMachine.g:1090:6: ( (lv_paths_24_0= rulePath ) )*
                                    loop26:
                                    do {
                                        int alt26=2;
                                        int LA26_0 = input.LA(1);

                                        if ( (LA26_0==RULE_ID||LA26_0==40) ) {
                                            alt26=1;
                                        }


                                        switch (alt26) {
                                    	case 1 :
                                    	    // InternalMachine.g:1091:7: (lv_paths_24_0= rulePath )
                                    	    {
                                    	    // InternalMachine.g:1091:7: (lv_paths_24_0= rulePath )
                                    	    // InternalMachine.g:1092:8: lv_paths_24_0= rulePath
                                    	    {

                                    	    								newCompositeNode(grammarAccess.getPeripheralAccess().getPathsPathParserRuleCall_3_1_8_2_0());
                                    	    							
                                    	    pushFollow(FOLLOW_31);
                                    	    lv_paths_24_0=rulePath();

                                    	    state._fsp--;


                                    	    								if (current==null) {
                                    	    									current = createModelElementForParent(grammarAccess.getPeripheralRule());
                                    	    								}
                                    	    								add(
                                    	    									current,
                                    	    									"paths",
                                    	    									lv_paths_24_0,
                                    	    									"org.eclipse.lsat.machine.teditor.Machine.Path");
                                    	    								afterParserOrEnumRuleCall();
                                    	    							

                                    	    }


                                    	    }
                                    	    break;

                                    	default :
                                    	    break loop26;
                                        }
                                    } while (true);

                                    otherlv_25=(Token)match(input,14,FOLLOW_14); 

                                    						newLeafNode(otherlv_25, grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_8_3());
                                    					

                                    }
                                    break;

                            }


                            }
                            break;

                    }

                    otherlv_26=(Token)match(input,14,FOLLOW_2); 

                    				newLeafNode(otherlv_26, grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_2());
                    			

                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePeripheral"


    // $ANTLR start "entryRuleDistance"
    // InternalMachine.g:1124:1: entryRuleDistance returns [EObject current=null] : iv_ruleDistance= ruleDistance EOF ;
    public final EObject entryRuleDistance() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDistance = null;


        try {
            // InternalMachine.g:1124:49: (iv_ruleDistance= ruleDistance EOF )
            // InternalMachine.g:1125:2: iv_ruleDistance= ruleDistance EOF
            {
             newCompositeNode(grammarAccess.getDistanceRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDistance=ruleDistance();

            state._fsp--;

             current =iv_ruleDistance; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDistance"


    // $ANTLR start "ruleDistance"
    // InternalMachine.g:1131:1: ruleDistance returns [EObject current=null] : ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ']' )? ) ;
    public final EObject ruleDistance() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;


        	enterRule();

        try {
            // InternalMachine.g:1137:2: ( ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ']' )? ) )
            // InternalMachine.g:1138:2: ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ']' )? )
            {
            // InternalMachine.g:1138:2: ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ']' )? )
            // InternalMachine.g:1139:3: () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ']' )?
            {
            // InternalMachine.g:1139:3: ()
            // InternalMachine.g:1140:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getDistanceAccess().getDistanceAction_0(),
            					current);
            			

            }

            // InternalMachine.g:1146:3: ( (lv_name_1_0= RULE_ID ) )
            // InternalMachine.g:1147:4: (lv_name_1_0= RULE_ID )
            {
            // InternalMachine.g:1147:4: (lv_name_1_0= RULE_ID )
            // InternalMachine.g:1148:5: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_15); 

            					newLeafNode(lv_name_1_0, grammarAccess.getDistanceAccess().getNameIDTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getDistanceRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_1_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }

            // InternalMachine.g:1164:3: (otherlv_2= '[' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ']' )?
            int alt31=2;
            int LA31_0 = input.LA(1);

            if ( (LA31_0==21) ) {
                alt31=1;
            }
            switch (alt31) {
                case 1 :
                    // InternalMachine.g:1165:4: otherlv_2= '[' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ']'
                    {
                    otherlv_2=(Token)match(input,21,FOLLOW_4); 

                    				newLeafNode(otherlv_2, grammarAccess.getDistanceAccess().getLeftSquareBracketKeyword_2_0());
                    			
                    // InternalMachine.g:1169:4: ( (otherlv_3= RULE_ID ) )
                    // InternalMachine.g:1170:5: (otherlv_3= RULE_ID )
                    {
                    // InternalMachine.g:1170:5: (otherlv_3= RULE_ID )
                    // InternalMachine.g:1171:6: otherlv_3= RULE_ID
                    {

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getDistanceRule());
                    						}
                    					
                    otherlv_3=(Token)match(input,RULE_ID,FOLLOW_32); 

                    						newLeafNode(otherlv_3, grammarAccess.getDistanceAccess().getSettlingAxisCrossReference_2_1_0());
                    					

                    }


                    }

                    // InternalMachine.g:1182:4: (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )*
                    loop30:
                    do {
                        int alt30=2;
                        int LA30_0 = input.LA(1);

                        if ( (LA30_0==24) ) {
                            alt30=1;
                        }


                        switch (alt30) {
                    	case 1 :
                    	    // InternalMachine.g:1183:5: otherlv_4= ',' ( (otherlv_5= RULE_ID ) )
                    	    {
                    	    otherlv_4=(Token)match(input,24,FOLLOW_4); 

                    	    					newLeafNode(otherlv_4, grammarAccess.getDistanceAccess().getCommaKeyword_2_2_0());
                    	    				
                    	    // InternalMachine.g:1187:5: ( (otherlv_5= RULE_ID ) )
                    	    // InternalMachine.g:1188:6: (otherlv_5= RULE_ID )
                    	    {
                    	    // InternalMachine.g:1188:6: (otherlv_5= RULE_ID )
                    	    // InternalMachine.g:1189:7: otherlv_5= RULE_ID
                    	    {

                    	    							if (current==null) {
                    	    								current = createModelElement(grammarAccess.getDistanceRule());
                    	    							}
                    	    						
                    	    otherlv_5=(Token)match(input,RULE_ID,FOLLOW_32); 

                    	    							newLeafNode(otherlv_5, grammarAccess.getDistanceAccess().getSettlingAxisCrossReference_2_2_1_0());
                    	    						

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop30;
                        }
                    } while (true);

                    otherlv_6=(Token)match(input,22,FOLLOW_2); 

                    				newLeafNode(otherlv_6, grammarAccess.getDistanceAccess().getRightSquareBracketKeyword_2_3());
                    			

                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDistance"


    // $ANTLR start "entryRuleAxisPositionsMapEntry"
    // InternalMachine.g:1210:1: entryRuleAxisPositionsMapEntry returns [EObject current=null] : iv_ruleAxisPositionsMapEntry= ruleAxisPositionsMapEntry EOF ;
    public final EObject entryRuleAxisPositionsMapEntry() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAxisPositionsMapEntry = null;


        try {
            // InternalMachine.g:1210:62: (iv_ruleAxisPositionsMapEntry= ruleAxisPositionsMapEntry EOF )
            // InternalMachine.g:1211:2: iv_ruleAxisPositionsMapEntry= ruleAxisPositionsMapEntry EOF
            {
             newCompositeNode(grammarAccess.getAxisPositionsMapEntryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleAxisPositionsMapEntry=ruleAxisPositionsMapEntry();

            state._fsp--;

             current =iv_ruleAxisPositionsMapEntry; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAxisPositionsMapEntry"


    // $ANTLR start "ruleAxisPositionsMapEntry"
    // InternalMachine.g:1217:1: ruleAxisPositionsMapEntry returns [EObject current=null] : ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '(' ( (lv_value_3_0= rulePosition ) ) (otherlv_4= ',' ( (lv_value_5_0= rulePosition ) ) )* otherlv_6= ')' )? ) ;
    public final EObject ruleAxisPositionsMapEntry() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        EObject lv_value_3_0 = null;

        EObject lv_value_5_0 = null;



        	enterRule();

        try {
            // InternalMachine.g:1223:2: ( ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '(' ( (lv_value_3_0= rulePosition ) ) (otherlv_4= ',' ( (lv_value_5_0= rulePosition ) ) )* otherlv_6= ')' )? ) )
            // InternalMachine.g:1224:2: ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '(' ( (lv_value_3_0= rulePosition ) ) (otherlv_4= ',' ( (lv_value_5_0= rulePosition ) ) )* otherlv_6= ')' )? )
            {
            // InternalMachine.g:1224:2: ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '(' ( (lv_value_3_0= rulePosition ) ) (otherlv_4= ',' ( (lv_value_5_0= rulePosition ) ) )* otherlv_6= ')' )? )
            // InternalMachine.g:1225:3: () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '(' ( (lv_value_3_0= rulePosition ) ) (otherlv_4= ',' ( (lv_value_5_0= rulePosition ) ) )* otherlv_6= ')' )?
            {
            // InternalMachine.g:1225:3: ()
            // InternalMachine.g:1226:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getAxisPositionsMapEntryAccess().getAxisPositionsMapEntryAction_0(),
            					current);
            			

            }

            // InternalMachine.g:1232:3: ( (otherlv_1= RULE_ID ) )
            // InternalMachine.g:1233:4: (otherlv_1= RULE_ID )
            {
            // InternalMachine.g:1233:4: (otherlv_1= RULE_ID )
            // InternalMachine.g:1234:5: otherlv_1= RULE_ID
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getAxisPositionsMapEntryRule());
            					}
            				
            otherlv_1=(Token)match(input,RULE_ID,FOLLOW_33); 

            					newLeafNode(otherlv_1, grammarAccess.getAxisPositionsMapEntryAccess().getKeyAxisCrossReference_1_0());
            				

            }


            }

            // InternalMachine.g:1245:3: (otherlv_2= '(' ( (lv_value_3_0= rulePosition ) ) (otherlv_4= ',' ( (lv_value_5_0= rulePosition ) ) )* otherlv_6= ')' )?
            int alt33=2;
            int LA33_0 = input.LA(1);

            if ( (LA33_0==26) ) {
                alt33=1;
            }
            switch (alt33) {
                case 1 :
                    // InternalMachine.g:1246:4: otherlv_2= '(' ( (lv_value_3_0= rulePosition ) ) (otherlv_4= ',' ( (lv_value_5_0= rulePosition ) ) )* otherlv_6= ')'
                    {
                    otherlv_2=(Token)match(input,26,FOLLOW_4); 

                    				newLeafNode(otherlv_2, grammarAccess.getAxisPositionsMapEntryAccess().getLeftParenthesisKeyword_2_0());
                    			
                    // InternalMachine.g:1250:4: ( (lv_value_3_0= rulePosition ) )
                    // InternalMachine.g:1251:5: (lv_value_3_0= rulePosition )
                    {
                    // InternalMachine.g:1251:5: (lv_value_3_0= rulePosition )
                    // InternalMachine.g:1252:6: lv_value_3_0= rulePosition
                    {

                    						newCompositeNode(grammarAccess.getAxisPositionsMapEntryAccess().getValuePositionParserRuleCall_2_1_0());
                    					
                    pushFollow(FOLLOW_22);
                    lv_value_3_0=rulePosition();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getAxisPositionsMapEntryRule());
                    						}
                    						add(
                    							current,
                    							"value",
                    							lv_value_3_0,
                    							"org.eclipse.lsat.machine.teditor.Machine.Position");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    // InternalMachine.g:1269:4: (otherlv_4= ',' ( (lv_value_5_0= rulePosition ) ) )*
                    loop32:
                    do {
                        int alt32=2;
                        int LA32_0 = input.LA(1);

                        if ( (LA32_0==24) ) {
                            alt32=1;
                        }


                        switch (alt32) {
                    	case 1 :
                    	    // InternalMachine.g:1270:5: otherlv_4= ',' ( (lv_value_5_0= rulePosition ) )
                    	    {
                    	    otherlv_4=(Token)match(input,24,FOLLOW_4); 

                    	    					newLeafNode(otherlv_4, grammarAccess.getAxisPositionsMapEntryAccess().getCommaKeyword_2_2_0());
                    	    				
                    	    // InternalMachine.g:1274:5: ( (lv_value_5_0= rulePosition ) )
                    	    // InternalMachine.g:1275:6: (lv_value_5_0= rulePosition )
                    	    {
                    	    // InternalMachine.g:1275:6: (lv_value_5_0= rulePosition )
                    	    // InternalMachine.g:1276:7: lv_value_5_0= rulePosition
                    	    {

                    	    							newCompositeNode(grammarAccess.getAxisPositionsMapEntryAccess().getValuePositionParserRuleCall_2_2_1_0());
                    	    						
                    	    pushFollow(FOLLOW_22);
                    	    lv_value_5_0=rulePosition();

                    	    state._fsp--;


                    	    							if (current==null) {
                    	    								current = createModelElementForParent(grammarAccess.getAxisPositionsMapEntryRule());
                    	    							}
                    	    							add(
                    	    								current,
                    	    								"value",
                    	    								lv_value_5_0,
                    	    								"org.eclipse.lsat.machine.teditor.Machine.Position");
                    	    							afterParserOrEnumRuleCall();
                    	    						

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop32;
                        }
                    } while (true);

                    otherlv_6=(Token)match(input,27,FOLLOW_2); 

                    				newLeafNode(otherlv_6, grammarAccess.getAxisPositionsMapEntryAccess().getRightParenthesisKeyword_2_3());
                    			

                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAxisPositionsMapEntry"


    // $ANTLR start "entryRulePosition"
    // InternalMachine.g:1303:1: entryRulePosition returns [EObject current=null] : iv_rulePosition= rulePosition EOF ;
    public final EObject entryRulePosition() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePosition = null;


        try {
            // InternalMachine.g:1303:49: (iv_rulePosition= rulePosition EOF )
            // InternalMachine.g:1304:2: iv_rulePosition= rulePosition EOF
            {
             newCompositeNode(grammarAccess.getPositionRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePosition=rulePosition();

            state._fsp--;

             current =iv_rulePosition; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePosition"


    // $ANTLR start "rulePosition"
    // InternalMachine.g:1310:1: rulePosition returns [EObject current=null] : ( () ( (lv_name_1_0= RULE_ID ) ) ) ;
    public final EObject rulePosition() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;


        	enterRule();

        try {
            // InternalMachine.g:1316:2: ( ( () ( (lv_name_1_0= RULE_ID ) ) ) )
            // InternalMachine.g:1317:2: ( () ( (lv_name_1_0= RULE_ID ) ) )
            {
            // InternalMachine.g:1317:2: ( () ( (lv_name_1_0= RULE_ID ) ) )
            // InternalMachine.g:1318:3: () ( (lv_name_1_0= RULE_ID ) )
            {
            // InternalMachine.g:1318:3: ()
            // InternalMachine.g:1319:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getPositionAccess().getPositionAction_0(),
            					current);
            			

            }

            // InternalMachine.g:1325:3: ( (lv_name_1_0= RULE_ID ) )
            // InternalMachine.g:1326:4: (lv_name_1_0= RULE_ID )
            {
            // InternalMachine.g:1326:4: (lv_name_1_0= RULE_ID )
            // InternalMachine.g:1327:5: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_2); 

            					newLeafNode(lv_name_1_0, grammarAccess.getPositionAccess().getNameIDTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getPositionRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_1_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePosition"


    // $ANTLR start "entryRuleSymbolicPosition"
    // InternalMachine.g:1347:1: entryRuleSymbolicPosition returns [EObject current=null] : iv_ruleSymbolicPosition= ruleSymbolicPosition EOF ;
    public final EObject entryRuleSymbolicPosition() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSymbolicPosition = null;


        try {
            // InternalMachine.g:1347:57: (iv_ruleSymbolicPosition= ruleSymbolicPosition EOF )
            // InternalMachine.g:1348:2: iv_ruleSymbolicPosition= ruleSymbolicPosition EOF
            {
             newCompositeNode(grammarAccess.getSymbolicPositionRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleSymbolicPosition=ruleSymbolicPosition();

            state._fsp--;

             current =iv_ruleSymbolicPosition; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSymbolicPosition"


    // $ANTLR start "ruleSymbolicPosition"
    // InternalMachine.g:1354:1: ruleSymbolicPosition returns [EObject current=null] : ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '(' ( (lv_axisPosition_3_0= ruleAxisPositionMapEntry ) ) (otherlv_4= ',' ( (lv_axisPosition_5_0= ruleAxisPositionMapEntry ) ) )* otherlv_6= ')' )? ) ;
    public final EObject ruleSymbolicPosition() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        EObject lv_axisPosition_3_0 = null;

        EObject lv_axisPosition_5_0 = null;



        	enterRule();

        try {
            // InternalMachine.g:1360:2: ( ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '(' ( (lv_axisPosition_3_0= ruleAxisPositionMapEntry ) ) (otherlv_4= ',' ( (lv_axisPosition_5_0= ruleAxisPositionMapEntry ) ) )* otherlv_6= ')' )? ) )
            // InternalMachine.g:1361:2: ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '(' ( (lv_axisPosition_3_0= ruleAxisPositionMapEntry ) ) (otherlv_4= ',' ( (lv_axisPosition_5_0= ruleAxisPositionMapEntry ) ) )* otherlv_6= ')' )? )
            {
            // InternalMachine.g:1361:2: ( () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '(' ( (lv_axisPosition_3_0= ruleAxisPositionMapEntry ) ) (otherlv_4= ',' ( (lv_axisPosition_5_0= ruleAxisPositionMapEntry ) ) )* otherlv_6= ')' )? )
            // InternalMachine.g:1362:3: () ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '(' ( (lv_axisPosition_3_0= ruleAxisPositionMapEntry ) ) (otherlv_4= ',' ( (lv_axisPosition_5_0= ruleAxisPositionMapEntry ) ) )* otherlv_6= ')' )?
            {
            // InternalMachine.g:1362:3: ()
            // InternalMachine.g:1363:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getSymbolicPositionAccess().getSymbolicPositionAction_0(),
            					current);
            			

            }

            // InternalMachine.g:1369:3: ( (lv_name_1_0= RULE_ID ) )
            // InternalMachine.g:1370:4: (lv_name_1_0= RULE_ID )
            {
            // InternalMachine.g:1370:4: (lv_name_1_0= RULE_ID )
            // InternalMachine.g:1371:5: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_33); 

            					newLeafNode(lv_name_1_0, grammarAccess.getSymbolicPositionAccess().getNameIDTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getSymbolicPositionRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_1_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }

            // InternalMachine.g:1387:3: (otherlv_2= '(' ( (lv_axisPosition_3_0= ruleAxisPositionMapEntry ) ) (otherlv_4= ',' ( (lv_axisPosition_5_0= ruleAxisPositionMapEntry ) ) )* otherlv_6= ')' )?
            int alt35=2;
            int LA35_0 = input.LA(1);

            if ( (LA35_0==26) ) {
                alt35=1;
            }
            switch (alt35) {
                case 1 :
                    // InternalMachine.g:1388:4: otherlv_2= '(' ( (lv_axisPosition_3_0= ruleAxisPositionMapEntry ) ) (otherlv_4= ',' ( (lv_axisPosition_5_0= ruleAxisPositionMapEntry ) ) )* otherlv_6= ')'
                    {
                    otherlv_2=(Token)match(input,26,FOLLOW_4); 

                    				newLeafNode(otherlv_2, grammarAccess.getSymbolicPositionAccess().getLeftParenthesisKeyword_2_0());
                    			
                    // InternalMachine.g:1392:4: ( (lv_axisPosition_3_0= ruleAxisPositionMapEntry ) )
                    // InternalMachine.g:1393:5: (lv_axisPosition_3_0= ruleAxisPositionMapEntry )
                    {
                    // InternalMachine.g:1393:5: (lv_axisPosition_3_0= ruleAxisPositionMapEntry )
                    // InternalMachine.g:1394:6: lv_axisPosition_3_0= ruleAxisPositionMapEntry
                    {

                    						newCompositeNode(grammarAccess.getSymbolicPositionAccess().getAxisPositionAxisPositionMapEntryParserRuleCall_2_1_0());
                    					
                    pushFollow(FOLLOW_22);
                    lv_axisPosition_3_0=ruleAxisPositionMapEntry();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getSymbolicPositionRule());
                    						}
                    						add(
                    							current,
                    							"axisPosition",
                    							lv_axisPosition_3_0,
                    							"org.eclipse.lsat.machine.teditor.Machine.AxisPositionMapEntry");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    // InternalMachine.g:1411:4: (otherlv_4= ',' ( (lv_axisPosition_5_0= ruleAxisPositionMapEntry ) ) )*
                    loop34:
                    do {
                        int alt34=2;
                        int LA34_0 = input.LA(1);

                        if ( (LA34_0==24) ) {
                            alt34=1;
                        }


                        switch (alt34) {
                    	case 1 :
                    	    // InternalMachine.g:1412:5: otherlv_4= ',' ( (lv_axisPosition_5_0= ruleAxisPositionMapEntry ) )
                    	    {
                    	    otherlv_4=(Token)match(input,24,FOLLOW_4); 

                    	    					newLeafNode(otherlv_4, grammarAccess.getSymbolicPositionAccess().getCommaKeyword_2_2_0());
                    	    				
                    	    // InternalMachine.g:1416:5: ( (lv_axisPosition_5_0= ruleAxisPositionMapEntry ) )
                    	    // InternalMachine.g:1417:6: (lv_axisPosition_5_0= ruleAxisPositionMapEntry )
                    	    {
                    	    // InternalMachine.g:1417:6: (lv_axisPosition_5_0= ruleAxisPositionMapEntry )
                    	    // InternalMachine.g:1418:7: lv_axisPosition_5_0= ruleAxisPositionMapEntry
                    	    {

                    	    							newCompositeNode(grammarAccess.getSymbolicPositionAccess().getAxisPositionAxisPositionMapEntryParserRuleCall_2_2_1_0());
                    	    						
                    	    pushFollow(FOLLOW_22);
                    	    lv_axisPosition_5_0=ruleAxisPositionMapEntry();

                    	    state._fsp--;


                    	    							if (current==null) {
                    	    								current = createModelElementForParent(grammarAccess.getSymbolicPositionRule());
                    	    							}
                    	    							add(
                    	    								current,
                    	    								"axisPosition",
                    	    								lv_axisPosition_5_0,
                    	    								"org.eclipse.lsat.machine.teditor.Machine.AxisPositionMapEntry");
                    	    							afterParserOrEnumRuleCall();
                    	    						

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop34;
                        }
                    } while (true);

                    otherlv_6=(Token)match(input,27,FOLLOW_2); 

                    				newLeafNode(otherlv_6, grammarAccess.getSymbolicPositionAccess().getRightParenthesisKeyword_2_3());
                    			

                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSymbolicPosition"


    // $ANTLR start "entryRuleAxisPositionMapEntry"
    // InternalMachine.g:1445:1: entryRuleAxisPositionMapEntry returns [EObject current=null] : iv_ruleAxisPositionMapEntry= ruleAxisPositionMapEntry EOF ;
    public final EObject entryRuleAxisPositionMapEntry() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAxisPositionMapEntry = null;


        try {
            // InternalMachine.g:1445:61: (iv_ruleAxisPositionMapEntry= ruleAxisPositionMapEntry EOF )
            // InternalMachine.g:1446:2: iv_ruleAxisPositionMapEntry= ruleAxisPositionMapEntry EOF
            {
             newCompositeNode(grammarAccess.getAxisPositionMapEntryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleAxisPositionMapEntry=ruleAxisPositionMapEntry();

            state._fsp--;

             current =iv_ruleAxisPositionMapEntry; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAxisPositionMapEntry"


    // $ANTLR start "ruleAxisPositionMapEntry"
    // InternalMachine.g:1452:1: ruleAxisPositionMapEntry returns [EObject current=null] : ( () ( (otherlv_1= RULE_ID ) ) otherlv_2= '.' ( (otherlv_3= RULE_ID ) ) ) ;
    public final EObject ruleAxisPositionMapEntry() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_3=null;


        	enterRule();

        try {
            // InternalMachine.g:1458:2: ( ( () ( (otherlv_1= RULE_ID ) ) otherlv_2= '.' ( (otherlv_3= RULE_ID ) ) ) )
            // InternalMachine.g:1459:2: ( () ( (otherlv_1= RULE_ID ) ) otherlv_2= '.' ( (otherlv_3= RULE_ID ) ) )
            {
            // InternalMachine.g:1459:2: ( () ( (otherlv_1= RULE_ID ) ) otherlv_2= '.' ( (otherlv_3= RULE_ID ) ) )
            // InternalMachine.g:1460:3: () ( (otherlv_1= RULE_ID ) ) otherlv_2= '.' ( (otherlv_3= RULE_ID ) )
            {
            // InternalMachine.g:1460:3: ()
            // InternalMachine.g:1461:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getAxisPositionMapEntryAccess().getAxisPositionMapEntryAction_0(),
            					current);
            			

            }

            // InternalMachine.g:1467:3: ( (otherlv_1= RULE_ID ) )
            // InternalMachine.g:1468:4: (otherlv_1= RULE_ID )
            {
            // InternalMachine.g:1468:4: (otherlv_1= RULE_ID )
            // InternalMachine.g:1469:5: otherlv_1= RULE_ID
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getAxisPositionMapEntryRule());
            					}
            				
            otherlv_1=(Token)match(input,RULE_ID,FOLLOW_34); 

            					newLeafNode(otherlv_1, grammarAccess.getAxisPositionMapEntryAccess().getKeyAxisCrossReference_1_0());
            				

            }


            }

            otherlv_2=(Token)match(input,34,FOLLOW_4); 

            			newLeafNode(otherlv_2, grammarAccess.getAxisPositionMapEntryAccess().getFullStopKeyword_2());
            		
            // InternalMachine.g:1484:3: ( (otherlv_3= RULE_ID ) )
            // InternalMachine.g:1485:4: (otherlv_3= RULE_ID )
            {
            // InternalMachine.g:1485:4: (otherlv_3= RULE_ID )
            // InternalMachine.g:1486:5: otherlv_3= RULE_ID
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getAxisPositionMapEntryRule());
            					}
            				
            otherlv_3=(Token)match(input,RULE_ID,FOLLOW_2); 

            					newLeafNode(otherlv_3, grammarAccess.getAxisPositionMapEntryAccess().getValuePositionCrossReference_3_0());
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAxisPositionMapEntry"


    // $ANTLR start "entryRuleProfile"
    // InternalMachine.g:1501:1: entryRuleProfile returns [EObject current=null] : iv_ruleProfile= ruleProfile EOF ;
    public final EObject entryRuleProfile() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleProfile = null;


        try {
            // InternalMachine.g:1501:48: (iv_ruleProfile= ruleProfile EOF )
            // InternalMachine.g:1502:2: iv_ruleProfile= ruleProfile EOF
            {
             newCompositeNode(grammarAccess.getProfileRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleProfile=ruleProfile();

            state._fsp--;

             current =iv_ruleProfile; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleProfile"


    // $ANTLR start "ruleProfile"
    // InternalMachine.g:1508:1: ruleProfile returns [EObject current=null] : ( () ( (lv_name_1_0= RULE_ID ) ) ) ;
    public final EObject ruleProfile() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;


        	enterRule();

        try {
            // InternalMachine.g:1514:2: ( ( () ( (lv_name_1_0= RULE_ID ) ) ) )
            // InternalMachine.g:1515:2: ( () ( (lv_name_1_0= RULE_ID ) ) )
            {
            // InternalMachine.g:1515:2: ( () ( (lv_name_1_0= RULE_ID ) ) )
            // InternalMachine.g:1516:3: () ( (lv_name_1_0= RULE_ID ) )
            {
            // InternalMachine.g:1516:3: ()
            // InternalMachine.g:1517:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getProfileAccess().getProfileAction_0(),
            					current);
            			

            }

            // InternalMachine.g:1523:3: ( (lv_name_1_0= RULE_ID ) )
            // InternalMachine.g:1524:4: (lv_name_1_0= RULE_ID )
            {
            // InternalMachine.g:1524:4: (lv_name_1_0= RULE_ID )
            // InternalMachine.g:1525:5: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_2); 

            					newLeafNode(lv_name_1_0, grammarAccess.getProfileAccess().getNameIDTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getProfileRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_1_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleProfile"


    // $ANTLR start "entryRulePath"
    // InternalMachine.g:1545:1: entryRulePath returns [EObject current=null] : iv_rulePath= rulePath EOF ;
    public final EObject entryRulePath() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePath = null;


        try {
            // InternalMachine.g:1545:45: (iv_rulePath= rulePath EOF )
            // InternalMachine.g:1546:2: iv_rulePath= rulePath EOF
            {
             newCompositeNode(grammarAccess.getPathRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePath=rulePath();

            state._fsp--;

             current =iv_rulePath; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePath"


    // $ANTLR start "rulePath"
    // InternalMachine.g:1552:1: rulePath returns [EObject current=null] : (this_UnidirectionalPath_0= ruleUnidirectionalPath | this_BidirectionalPath_1= ruleBidirectionalPath | this_FullMeshPath_2= ruleFullMeshPath ) ;
    public final EObject rulePath() throws RecognitionException {
        EObject current = null;

        EObject this_UnidirectionalPath_0 = null;

        EObject this_BidirectionalPath_1 = null;

        EObject this_FullMeshPath_2 = null;



        	enterRule();

        try {
            // InternalMachine.g:1558:2: ( (this_UnidirectionalPath_0= ruleUnidirectionalPath | this_BidirectionalPath_1= ruleBidirectionalPath | this_FullMeshPath_2= ruleFullMeshPath ) )
            // InternalMachine.g:1559:2: (this_UnidirectionalPath_0= ruleUnidirectionalPath | this_BidirectionalPath_1= ruleBidirectionalPath | this_FullMeshPath_2= ruleFullMeshPath )
            {
            // InternalMachine.g:1559:2: (this_UnidirectionalPath_0= ruleUnidirectionalPath | this_BidirectionalPath_1= ruleBidirectionalPath | this_FullMeshPath_2= ruleFullMeshPath )
            int alt36=3;
            int LA36_0 = input.LA(1);

            if ( (LA36_0==RULE_ID) ) {
                int LA36_1 = input.LA(2);

                if ( (LA36_1==21||LA36_1==39) ) {
                    alt36=2;
                }
                else if ( (LA36_1==35) ) {
                    alt36=1;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 36, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA36_0==40) ) {
                alt36=3;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 36, 0, input);

                throw nvae;
            }
            switch (alt36) {
                case 1 :
                    // InternalMachine.g:1560:3: this_UnidirectionalPath_0= ruleUnidirectionalPath
                    {

                    			newCompositeNode(grammarAccess.getPathAccess().getUnidirectionalPathParserRuleCall_0());
                    		
                    pushFollow(FOLLOW_2);
                    this_UnidirectionalPath_0=ruleUnidirectionalPath();

                    state._fsp--;


                    			current = this_UnidirectionalPath_0;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;
                case 2 :
                    // InternalMachine.g:1569:3: this_BidirectionalPath_1= ruleBidirectionalPath
                    {

                    			newCompositeNode(grammarAccess.getPathAccess().getBidirectionalPathParserRuleCall_1());
                    		
                    pushFollow(FOLLOW_2);
                    this_BidirectionalPath_1=ruleBidirectionalPath();

                    state._fsp--;


                    			current = this_BidirectionalPath_1;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;
                case 3 :
                    // InternalMachine.g:1578:3: this_FullMeshPath_2= ruleFullMeshPath
                    {

                    			newCompositeNode(grammarAccess.getPathAccess().getFullMeshPathParserRuleCall_2());
                    		
                    pushFollow(FOLLOW_2);
                    this_FullMeshPath_2=ruleFullMeshPath();

                    state._fsp--;


                    			current = this_FullMeshPath_2;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePath"


    // $ANTLR start "entryRuleUnidirectionalPath"
    // InternalMachine.g:1590:1: entryRuleUnidirectionalPath returns [EObject current=null] : iv_ruleUnidirectionalPath= ruleUnidirectionalPath EOF ;
    public final EObject entryRuleUnidirectionalPath() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleUnidirectionalPath = null;


        try {
            // InternalMachine.g:1590:59: (iv_ruleUnidirectionalPath= ruleUnidirectionalPath EOF )
            // InternalMachine.g:1591:2: iv_ruleUnidirectionalPath= ruleUnidirectionalPath EOF
            {
             newCompositeNode(grammarAccess.getUnidirectionalPathRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleUnidirectionalPath=ruleUnidirectionalPath();

            state._fsp--;

             current =iv_ruleUnidirectionalPath; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleUnidirectionalPath"


    // $ANTLR start "ruleUnidirectionalPath"
    // InternalMachine.g:1597:1: ruleUnidirectionalPath returns [EObject current=null] : ( () ( (otherlv_1= RULE_ID ) ) otherlv_2= '-->' ( (lv_target_3_0= rulePathTargetReference ) ) ( (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* ) | (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) ) ) (otherlv_10= '@' ( (otherlv_11= RULE_ID ) ) )* ) ;
    public final EObject ruleUnidirectionalPath() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_8=null;
        Token otherlv_9=null;
        Token otherlv_10=null;
        Token otherlv_11=null;
        EObject lv_target_3_0 = null;



        	enterRule();

        try {
            // InternalMachine.g:1603:2: ( ( () ( (otherlv_1= RULE_ID ) ) otherlv_2= '-->' ( (lv_target_3_0= rulePathTargetReference ) ) ( (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* ) | (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) ) ) (otherlv_10= '@' ( (otherlv_11= RULE_ID ) ) )* ) )
            // InternalMachine.g:1604:2: ( () ( (otherlv_1= RULE_ID ) ) otherlv_2= '-->' ( (lv_target_3_0= rulePathTargetReference ) ) ( (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* ) | (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) ) ) (otherlv_10= '@' ( (otherlv_11= RULE_ID ) ) )* )
            {
            // InternalMachine.g:1604:2: ( () ( (otherlv_1= RULE_ID ) ) otherlv_2= '-->' ( (lv_target_3_0= rulePathTargetReference ) ) ( (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* ) | (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) ) ) (otherlv_10= '@' ( (otherlv_11= RULE_ID ) ) )* )
            // InternalMachine.g:1605:3: () ( (otherlv_1= RULE_ID ) ) otherlv_2= '-->' ( (lv_target_3_0= rulePathTargetReference ) ) ( (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* ) | (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) ) ) (otherlv_10= '@' ( (otherlv_11= RULE_ID ) ) )*
            {
            // InternalMachine.g:1605:3: ()
            // InternalMachine.g:1606:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getUnidirectionalPathAccess().getUnidirectionalPathAction_0(),
            					current);
            			

            }

            // InternalMachine.g:1612:3: ( (otherlv_1= RULE_ID ) )
            // InternalMachine.g:1613:4: (otherlv_1= RULE_ID )
            {
            // InternalMachine.g:1613:4: (otherlv_1= RULE_ID )
            // InternalMachine.g:1614:5: otherlv_1= RULE_ID
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getUnidirectionalPathRule());
            					}
            				
            otherlv_1=(Token)match(input,RULE_ID,FOLLOW_35); 

            					newLeafNode(otherlv_1, grammarAccess.getUnidirectionalPathAccess().getSourceSymbolicPositionCrossReference_1_0());
            				

            }


            }

            otherlv_2=(Token)match(input,35,FOLLOW_4); 

            			newLeafNode(otherlv_2, grammarAccess.getUnidirectionalPathAccess().getHyphenMinusHyphenMinusGreaterThanSignKeyword_2());
            		
            // InternalMachine.g:1629:3: ( (lv_target_3_0= rulePathTargetReference ) )
            // InternalMachine.g:1630:4: (lv_target_3_0= rulePathTargetReference )
            {
            // InternalMachine.g:1630:4: (lv_target_3_0= rulePathTargetReference )
            // InternalMachine.g:1631:5: lv_target_3_0= rulePathTargetReference
            {

            					newCompositeNode(grammarAccess.getUnidirectionalPathAccess().getTargetPathTargetReferenceParserRuleCall_3_0());
            				
            pushFollow(FOLLOW_36);
            lv_target_3_0=rulePathTargetReference();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getUnidirectionalPathRule());
            					}
            					set(
            						current,
            						"target",
            						lv_target_3_0,
            						"org.eclipse.lsat.machine.teditor.Machine.PathTargetReference");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalMachine.g:1648:3: ( (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* ) | (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) ) )
            int alt38=2;
            int LA38_0 = input.LA(1);

            if ( (LA38_0==36) ) {
                alt38=1;
            }
            else if ( (LA38_0==37) ) {
                alt38=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 38, 0, input);

                throw nvae;
            }
            switch (alt38) {
                case 1 :
                    // InternalMachine.g:1649:4: (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )
                    {
                    // InternalMachine.g:1649:4: (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )
                    // InternalMachine.g:1650:5: otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )*
                    {
                    otherlv_4=(Token)match(input,36,FOLLOW_4); 

                    					newLeafNode(otherlv_4, grammarAccess.getUnidirectionalPathAccess().getProfilesKeyword_4_0_0());
                    				
                    // InternalMachine.g:1654:5: ( (otherlv_5= RULE_ID ) )
                    // InternalMachine.g:1655:6: (otherlv_5= RULE_ID )
                    {
                    // InternalMachine.g:1655:6: (otherlv_5= RULE_ID )
                    // InternalMachine.g:1656:7: otherlv_5= RULE_ID
                    {

                    							if (current==null) {
                    								current = createModelElement(grammarAccess.getUnidirectionalPathRule());
                    							}
                    						
                    otherlv_5=(Token)match(input,RULE_ID,FOLLOW_37); 

                    							newLeafNode(otherlv_5, grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_0_1_0());
                    						

                    }


                    }

                    // InternalMachine.g:1667:5: (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )*
                    loop37:
                    do {
                        int alt37=2;
                        int LA37_0 = input.LA(1);

                        if ( (LA37_0==24) ) {
                            alt37=1;
                        }


                        switch (alt37) {
                    	case 1 :
                    	    // InternalMachine.g:1668:6: otherlv_6= ',' ( (otherlv_7= RULE_ID ) )
                    	    {
                    	    otherlv_6=(Token)match(input,24,FOLLOW_4); 

                    	    						newLeafNode(otherlv_6, grammarAccess.getUnidirectionalPathAccess().getCommaKeyword_4_0_2_0());
                    	    					
                    	    // InternalMachine.g:1672:6: ( (otherlv_7= RULE_ID ) )
                    	    // InternalMachine.g:1673:7: (otherlv_7= RULE_ID )
                    	    {
                    	    // InternalMachine.g:1673:7: (otherlv_7= RULE_ID )
                    	    // InternalMachine.g:1674:8: otherlv_7= RULE_ID
                    	    {

                    	    								if (current==null) {
                    	    									current = createModelElement(grammarAccess.getUnidirectionalPathRule());
                    	    								}
                    	    							
                    	    otherlv_7=(Token)match(input,RULE_ID,FOLLOW_37); 

                    	    								newLeafNode(otherlv_7, grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_0_2_1_0());
                    	    							

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop37;
                        }
                    } while (true);


                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:1688:4: (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) )
                    {
                    // InternalMachine.g:1688:4: (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) )
                    // InternalMachine.g:1689:5: otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) )
                    {
                    otherlv_8=(Token)match(input,37,FOLLOW_4); 

                    					newLeafNode(otherlv_8, grammarAccess.getUnidirectionalPathAccess().getProfileKeyword_4_1_0());
                    				
                    // InternalMachine.g:1693:5: ( (otherlv_9= RULE_ID ) )
                    // InternalMachine.g:1694:6: (otherlv_9= RULE_ID )
                    {
                    // InternalMachine.g:1694:6: (otherlv_9= RULE_ID )
                    // InternalMachine.g:1695:7: otherlv_9= RULE_ID
                    {

                    							if (current==null) {
                    								current = createModelElement(grammarAccess.getUnidirectionalPathRule());
                    							}
                    						
                    otherlv_9=(Token)match(input,RULE_ID,FOLLOW_38); 

                    							newLeafNode(otherlv_9, grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_1_1_0());
                    						

                    }


                    }


                    }


                    }
                    break;

            }

            // InternalMachine.g:1708:3: (otherlv_10= '@' ( (otherlv_11= RULE_ID ) ) )*
            loop39:
            do {
                int alt39=2;
                int LA39_0 = input.LA(1);

                if ( (LA39_0==38) ) {
                    alt39=1;
                }


                switch (alt39) {
            	case 1 :
            	    // InternalMachine.g:1709:4: otherlv_10= '@' ( (otherlv_11= RULE_ID ) )
            	    {
            	    otherlv_10=(Token)match(input,38,FOLLOW_4); 

            	    				newLeafNode(otherlv_10, grammarAccess.getUnidirectionalPathAccess().getCommercialAtKeyword_5_0());
            	    			
            	    // InternalMachine.g:1713:4: ( (otherlv_11= RULE_ID ) )
            	    // InternalMachine.g:1714:5: (otherlv_11= RULE_ID )
            	    {
            	    // InternalMachine.g:1714:5: (otherlv_11= RULE_ID )
            	    // InternalMachine.g:1715:6: otherlv_11= RULE_ID
            	    {

            	    						if (current==null) {
            	    							current = createModelElement(grammarAccess.getUnidirectionalPathRule());
            	    						}
            	    					
            	    otherlv_11=(Token)match(input,RULE_ID,FOLLOW_38); 

            	    						newLeafNode(otherlv_11, grammarAccess.getUnidirectionalPathAccess().getAnnotationsPathAnnotationCrossReference_5_1_0());
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop39;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleUnidirectionalPath"


    // $ANTLR start "entryRuleBidirectionalPath"
    // InternalMachine.g:1731:1: entryRuleBidirectionalPath returns [EObject current=null] : iv_ruleBidirectionalPath= ruleBidirectionalPath EOF ;
    public final EObject entryRuleBidirectionalPath() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleBidirectionalPath = null;


        try {
            // InternalMachine.g:1731:58: (iv_ruleBidirectionalPath= ruleBidirectionalPath EOF )
            // InternalMachine.g:1732:2: iv_ruleBidirectionalPath= ruleBidirectionalPath EOF
            {
             newCompositeNode(grammarAccess.getBidirectionalPathRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleBidirectionalPath=ruleBidirectionalPath();

            state._fsp--;

             current =iv_ruleBidirectionalPath; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleBidirectionalPath"


    // $ANTLR start "ruleBidirectionalPath"
    // InternalMachine.g:1738:1: ruleBidirectionalPath returns [EObject current=null] : ( () ( (lv_endPoints_1_0= rulePathTargetReference ) ) otherlv_2= '<->' ( (lv_endPoints_3_0= rulePathTargetReference ) ) ( (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* ) | (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) ) ) (otherlv_10= '@' ( (otherlv_11= RULE_ID ) ) )* ) ;
    public final EObject ruleBidirectionalPath() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_8=null;
        Token otherlv_9=null;
        Token otherlv_10=null;
        Token otherlv_11=null;
        EObject lv_endPoints_1_0 = null;

        EObject lv_endPoints_3_0 = null;



        	enterRule();

        try {
            // InternalMachine.g:1744:2: ( ( () ( (lv_endPoints_1_0= rulePathTargetReference ) ) otherlv_2= '<->' ( (lv_endPoints_3_0= rulePathTargetReference ) ) ( (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* ) | (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) ) ) (otherlv_10= '@' ( (otherlv_11= RULE_ID ) ) )* ) )
            // InternalMachine.g:1745:2: ( () ( (lv_endPoints_1_0= rulePathTargetReference ) ) otherlv_2= '<->' ( (lv_endPoints_3_0= rulePathTargetReference ) ) ( (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* ) | (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) ) ) (otherlv_10= '@' ( (otherlv_11= RULE_ID ) ) )* )
            {
            // InternalMachine.g:1745:2: ( () ( (lv_endPoints_1_0= rulePathTargetReference ) ) otherlv_2= '<->' ( (lv_endPoints_3_0= rulePathTargetReference ) ) ( (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* ) | (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) ) ) (otherlv_10= '@' ( (otherlv_11= RULE_ID ) ) )* )
            // InternalMachine.g:1746:3: () ( (lv_endPoints_1_0= rulePathTargetReference ) ) otherlv_2= '<->' ( (lv_endPoints_3_0= rulePathTargetReference ) ) ( (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* ) | (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) ) ) (otherlv_10= '@' ( (otherlv_11= RULE_ID ) ) )*
            {
            // InternalMachine.g:1746:3: ()
            // InternalMachine.g:1747:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getBidirectionalPathAccess().getBidirectionalPathAction_0(),
            					current);
            			

            }

            // InternalMachine.g:1753:3: ( (lv_endPoints_1_0= rulePathTargetReference ) )
            // InternalMachine.g:1754:4: (lv_endPoints_1_0= rulePathTargetReference )
            {
            // InternalMachine.g:1754:4: (lv_endPoints_1_0= rulePathTargetReference )
            // InternalMachine.g:1755:5: lv_endPoints_1_0= rulePathTargetReference
            {

            					newCompositeNode(grammarAccess.getBidirectionalPathAccess().getEndPointsPathTargetReferenceParserRuleCall_1_0());
            				
            pushFollow(FOLLOW_39);
            lv_endPoints_1_0=rulePathTargetReference();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getBidirectionalPathRule());
            					}
            					add(
            						current,
            						"endPoints",
            						lv_endPoints_1_0,
            						"org.eclipse.lsat.machine.teditor.Machine.PathTargetReference");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_2=(Token)match(input,39,FOLLOW_4); 

            			newLeafNode(otherlv_2, grammarAccess.getBidirectionalPathAccess().getLessThanSignHyphenMinusGreaterThanSignKeyword_2());
            		
            // InternalMachine.g:1776:3: ( (lv_endPoints_3_0= rulePathTargetReference ) )
            // InternalMachine.g:1777:4: (lv_endPoints_3_0= rulePathTargetReference )
            {
            // InternalMachine.g:1777:4: (lv_endPoints_3_0= rulePathTargetReference )
            // InternalMachine.g:1778:5: lv_endPoints_3_0= rulePathTargetReference
            {

            					newCompositeNode(grammarAccess.getBidirectionalPathAccess().getEndPointsPathTargetReferenceParserRuleCall_3_0());
            				
            pushFollow(FOLLOW_36);
            lv_endPoints_3_0=rulePathTargetReference();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getBidirectionalPathRule());
            					}
            					add(
            						current,
            						"endPoints",
            						lv_endPoints_3_0,
            						"org.eclipse.lsat.machine.teditor.Machine.PathTargetReference");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalMachine.g:1795:3: ( (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* ) | (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) ) )
            int alt41=2;
            int LA41_0 = input.LA(1);

            if ( (LA41_0==36) ) {
                alt41=1;
            }
            else if ( (LA41_0==37) ) {
                alt41=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 41, 0, input);

                throw nvae;
            }
            switch (alt41) {
                case 1 :
                    // InternalMachine.g:1796:4: (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )
                    {
                    // InternalMachine.g:1796:4: (otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )
                    // InternalMachine.g:1797:5: otherlv_4= 'profiles' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )*
                    {
                    otherlv_4=(Token)match(input,36,FOLLOW_4); 

                    					newLeafNode(otherlv_4, grammarAccess.getBidirectionalPathAccess().getProfilesKeyword_4_0_0());
                    				
                    // InternalMachine.g:1801:5: ( (otherlv_5= RULE_ID ) )
                    // InternalMachine.g:1802:6: (otherlv_5= RULE_ID )
                    {
                    // InternalMachine.g:1802:6: (otherlv_5= RULE_ID )
                    // InternalMachine.g:1803:7: otherlv_5= RULE_ID
                    {

                    							if (current==null) {
                    								current = createModelElement(grammarAccess.getBidirectionalPathRule());
                    							}
                    						
                    otherlv_5=(Token)match(input,RULE_ID,FOLLOW_37); 

                    							newLeafNode(otherlv_5, grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_0_1_0());
                    						

                    }


                    }

                    // InternalMachine.g:1814:5: (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )*
                    loop40:
                    do {
                        int alt40=2;
                        int LA40_0 = input.LA(1);

                        if ( (LA40_0==24) ) {
                            alt40=1;
                        }


                        switch (alt40) {
                    	case 1 :
                    	    // InternalMachine.g:1815:6: otherlv_6= ',' ( (otherlv_7= RULE_ID ) )
                    	    {
                    	    otherlv_6=(Token)match(input,24,FOLLOW_4); 

                    	    						newLeafNode(otherlv_6, grammarAccess.getBidirectionalPathAccess().getCommaKeyword_4_0_2_0());
                    	    					
                    	    // InternalMachine.g:1819:6: ( (otherlv_7= RULE_ID ) )
                    	    // InternalMachine.g:1820:7: (otherlv_7= RULE_ID )
                    	    {
                    	    // InternalMachine.g:1820:7: (otherlv_7= RULE_ID )
                    	    // InternalMachine.g:1821:8: otherlv_7= RULE_ID
                    	    {

                    	    								if (current==null) {
                    	    									current = createModelElement(grammarAccess.getBidirectionalPathRule());
                    	    								}
                    	    							
                    	    otherlv_7=(Token)match(input,RULE_ID,FOLLOW_37); 

                    	    								newLeafNode(otherlv_7, grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_0_2_1_0());
                    	    							

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop40;
                        }
                    } while (true);


                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:1835:4: (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) )
                    {
                    // InternalMachine.g:1835:4: (otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) ) )
                    // InternalMachine.g:1836:5: otherlv_8= 'profile' ( (otherlv_9= RULE_ID ) )
                    {
                    otherlv_8=(Token)match(input,37,FOLLOW_4); 

                    					newLeafNode(otherlv_8, grammarAccess.getBidirectionalPathAccess().getProfileKeyword_4_1_0());
                    				
                    // InternalMachine.g:1840:5: ( (otherlv_9= RULE_ID ) )
                    // InternalMachine.g:1841:6: (otherlv_9= RULE_ID )
                    {
                    // InternalMachine.g:1841:6: (otherlv_9= RULE_ID )
                    // InternalMachine.g:1842:7: otherlv_9= RULE_ID
                    {

                    							if (current==null) {
                    								current = createModelElement(grammarAccess.getBidirectionalPathRule());
                    							}
                    						
                    otherlv_9=(Token)match(input,RULE_ID,FOLLOW_38); 

                    							newLeafNode(otherlv_9, grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_1_1_0());
                    						

                    }


                    }


                    }


                    }
                    break;

            }

            // InternalMachine.g:1855:3: (otherlv_10= '@' ( (otherlv_11= RULE_ID ) ) )*
            loop42:
            do {
                int alt42=2;
                int LA42_0 = input.LA(1);

                if ( (LA42_0==38) ) {
                    alt42=1;
                }


                switch (alt42) {
            	case 1 :
            	    // InternalMachine.g:1856:4: otherlv_10= '@' ( (otherlv_11= RULE_ID ) )
            	    {
            	    otherlv_10=(Token)match(input,38,FOLLOW_4); 

            	    				newLeafNode(otherlv_10, grammarAccess.getBidirectionalPathAccess().getCommercialAtKeyword_5_0());
            	    			
            	    // InternalMachine.g:1860:4: ( (otherlv_11= RULE_ID ) )
            	    // InternalMachine.g:1861:5: (otherlv_11= RULE_ID )
            	    {
            	    // InternalMachine.g:1861:5: (otherlv_11= RULE_ID )
            	    // InternalMachine.g:1862:6: otherlv_11= RULE_ID
            	    {

            	    						if (current==null) {
            	    							current = createModelElement(grammarAccess.getBidirectionalPathRule());
            	    						}
            	    					
            	    otherlv_11=(Token)match(input,RULE_ID,FOLLOW_38); 

            	    						newLeafNode(otherlv_11, grammarAccess.getBidirectionalPathAccess().getAnnotationsPathAnnotationCrossReference_5_1_0());
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop42;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleBidirectionalPath"


    // $ANTLR start "entryRuleFullMeshPath"
    // InternalMachine.g:1878:1: entryRuleFullMeshPath returns [EObject current=null] : iv_ruleFullMeshPath= ruleFullMeshPath EOF ;
    public final EObject entryRuleFullMeshPath() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleFullMeshPath = null;


        try {
            // InternalMachine.g:1878:53: (iv_ruleFullMeshPath= ruleFullMeshPath EOF )
            // InternalMachine.g:1879:2: iv_ruleFullMeshPath= ruleFullMeshPath EOF
            {
             newCompositeNode(grammarAccess.getFullMeshPathRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleFullMeshPath=ruleFullMeshPath();

            state._fsp--;

             current =iv_ruleFullMeshPath; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleFullMeshPath"


    // $ANTLR start "ruleFullMeshPath"
    // InternalMachine.g:1885:1: ruleFullMeshPath returns [EObject current=null] : ( () otherlv_1= 'FullMesh' otherlv_2= '{' ( (otherlv_3= 'profiles' ( (otherlv_4= RULE_ID ) ) (otherlv_5= ',' ( (otherlv_6= RULE_ID ) ) )* ) | (otherlv_7= 'profile' ( (otherlv_8= RULE_ID ) ) ) ) (otherlv_9= '@' ( (otherlv_10= RULE_ID ) ) )* ( (lv_endPoints_11_0= rulePathTargetReference ) )* otherlv_12= '}' ) ;
    public final EObject ruleFullMeshPath() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_8=null;
        Token otherlv_9=null;
        Token otherlv_10=null;
        Token otherlv_12=null;
        EObject lv_endPoints_11_0 = null;



        	enterRule();

        try {
            // InternalMachine.g:1891:2: ( ( () otherlv_1= 'FullMesh' otherlv_2= '{' ( (otherlv_3= 'profiles' ( (otherlv_4= RULE_ID ) ) (otherlv_5= ',' ( (otherlv_6= RULE_ID ) ) )* ) | (otherlv_7= 'profile' ( (otherlv_8= RULE_ID ) ) ) ) (otherlv_9= '@' ( (otherlv_10= RULE_ID ) ) )* ( (lv_endPoints_11_0= rulePathTargetReference ) )* otherlv_12= '}' ) )
            // InternalMachine.g:1892:2: ( () otherlv_1= 'FullMesh' otherlv_2= '{' ( (otherlv_3= 'profiles' ( (otherlv_4= RULE_ID ) ) (otherlv_5= ',' ( (otherlv_6= RULE_ID ) ) )* ) | (otherlv_7= 'profile' ( (otherlv_8= RULE_ID ) ) ) ) (otherlv_9= '@' ( (otherlv_10= RULE_ID ) ) )* ( (lv_endPoints_11_0= rulePathTargetReference ) )* otherlv_12= '}' )
            {
            // InternalMachine.g:1892:2: ( () otherlv_1= 'FullMesh' otherlv_2= '{' ( (otherlv_3= 'profiles' ( (otherlv_4= RULE_ID ) ) (otherlv_5= ',' ( (otherlv_6= RULE_ID ) ) )* ) | (otherlv_7= 'profile' ( (otherlv_8= RULE_ID ) ) ) ) (otherlv_9= '@' ( (otherlv_10= RULE_ID ) ) )* ( (lv_endPoints_11_0= rulePathTargetReference ) )* otherlv_12= '}' )
            // InternalMachine.g:1893:3: () otherlv_1= 'FullMesh' otherlv_2= '{' ( (otherlv_3= 'profiles' ( (otherlv_4= RULE_ID ) ) (otherlv_5= ',' ( (otherlv_6= RULE_ID ) ) )* ) | (otherlv_7= 'profile' ( (otherlv_8= RULE_ID ) ) ) ) (otherlv_9= '@' ( (otherlv_10= RULE_ID ) ) )* ( (lv_endPoints_11_0= rulePathTargetReference ) )* otherlv_12= '}'
            {
            // InternalMachine.g:1893:3: ()
            // InternalMachine.g:1894:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getFullMeshPathAccess().getFullMeshPathAction_0(),
            					current);
            			

            }

            otherlv_1=(Token)match(input,40,FOLLOW_6); 

            			newLeafNode(otherlv_1, grammarAccess.getFullMeshPathAccess().getFullMeshKeyword_1());
            		
            otherlv_2=(Token)match(input,13,FOLLOW_36); 

            			newLeafNode(otherlv_2, grammarAccess.getFullMeshPathAccess().getLeftCurlyBracketKeyword_2());
            		
            // InternalMachine.g:1908:3: ( (otherlv_3= 'profiles' ( (otherlv_4= RULE_ID ) ) (otherlv_5= ',' ( (otherlv_6= RULE_ID ) ) )* ) | (otherlv_7= 'profile' ( (otherlv_8= RULE_ID ) ) ) )
            int alt44=2;
            int LA44_0 = input.LA(1);

            if ( (LA44_0==36) ) {
                alt44=1;
            }
            else if ( (LA44_0==37) ) {
                alt44=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 44, 0, input);

                throw nvae;
            }
            switch (alt44) {
                case 1 :
                    // InternalMachine.g:1909:4: (otherlv_3= 'profiles' ( (otherlv_4= RULE_ID ) ) (otherlv_5= ',' ( (otherlv_6= RULE_ID ) ) )* )
                    {
                    // InternalMachine.g:1909:4: (otherlv_3= 'profiles' ( (otherlv_4= RULE_ID ) ) (otherlv_5= ',' ( (otherlv_6= RULE_ID ) ) )* )
                    // InternalMachine.g:1910:5: otherlv_3= 'profiles' ( (otherlv_4= RULE_ID ) ) (otherlv_5= ',' ( (otherlv_6= RULE_ID ) ) )*
                    {
                    otherlv_3=(Token)match(input,36,FOLLOW_4); 

                    					newLeafNode(otherlv_3, grammarAccess.getFullMeshPathAccess().getProfilesKeyword_3_0_0());
                    				
                    // InternalMachine.g:1914:5: ( (otherlv_4= RULE_ID ) )
                    // InternalMachine.g:1915:6: (otherlv_4= RULE_ID )
                    {
                    // InternalMachine.g:1915:6: (otherlv_4= RULE_ID )
                    // InternalMachine.g:1916:7: otherlv_4= RULE_ID
                    {

                    							if (current==null) {
                    								current = createModelElement(grammarAccess.getFullMeshPathRule());
                    							}
                    						
                    otherlv_4=(Token)match(input,RULE_ID,FOLLOW_40); 

                    							newLeafNode(otherlv_4, grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_0_1_0());
                    						

                    }


                    }

                    // InternalMachine.g:1927:5: (otherlv_5= ',' ( (otherlv_6= RULE_ID ) ) )*
                    loop43:
                    do {
                        int alt43=2;
                        int LA43_0 = input.LA(1);

                        if ( (LA43_0==24) ) {
                            alt43=1;
                        }


                        switch (alt43) {
                    	case 1 :
                    	    // InternalMachine.g:1928:6: otherlv_5= ',' ( (otherlv_6= RULE_ID ) )
                    	    {
                    	    otherlv_5=(Token)match(input,24,FOLLOW_4); 

                    	    						newLeafNode(otherlv_5, grammarAccess.getFullMeshPathAccess().getCommaKeyword_3_0_2_0());
                    	    					
                    	    // InternalMachine.g:1932:6: ( (otherlv_6= RULE_ID ) )
                    	    // InternalMachine.g:1933:7: (otherlv_6= RULE_ID )
                    	    {
                    	    // InternalMachine.g:1933:7: (otherlv_6= RULE_ID )
                    	    // InternalMachine.g:1934:8: otherlv_6= RULE_ID
                    	    {

                    	    								if (current==null) {
                    	    									current = createModelElement(grammarAccess.getFullMeshPathRule());
                    	    								}
                    	    							
                    	    otherlv_6=(Token)match(input,RULE_ID,FOLLOW_40); 

                    	    								newLeafNode(otherlv_6, grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_0_2_1_0());
                    	    							

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop43;
                        }
                    } while (true);


                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:1948:4: (otherlv_7= 'profile' ( (otherlv_8= RULE_ID ) ) )
                    {
                    // InternalMachine.g:1948:4: (otherlv_7= 'profile' ( (otherlv_8= RULE_ID ) ) )
                    // InternalMachine.g:1949:5: otherlv_7= 'profile' ( (otherlv_8= RULE_ID ) )
                    {
                    otherlv_7=(Token)match(input,37,FOLLOW_4); 

                    					newLeafNode(otherlv_7, grammarAccess.getFullMeshPathAccess().getProfileKeyword_3_1_0());
                    				
                    // InternalMachine.g:1953:5: ( (otherlv_8= RULE_ID ) )
                    // InternalMachine.g:1954:6: (otherlv_8= RULE_ID )
                    {
                    // InternalMachine.g:1954:6: (otherlv_8= RULE_ID )
                    // InternalMachine.g:1955:7: otherlv_8= RULE_ID
                    {

                    							if (current==null) {
                    								current = createModelElement(grammarAccess.getFullMeshPathRule());
                    							}
                    						
                    otherlv_8=(Token)match(input,RULE_ID,FOLLOW_41); 

                    							newLeafNode(otherlv_8, grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_1_1_0());
                    						

                    }


                    }


                    }


                    }
                    break;

            }

            // InternalMachine.g:1968:3: (otherlv_9= '@' ( (otherlv_10= RULE_ID ) ) )*
            loop45:
            do {
                int alt45=2;
                int LA45_0 = input.LA(1);

                if ( (LA45_0==38) ) {
                    alt45=1;
                }


                switch (alt45) {
            	case 1 :
            	    // InternalMachine.g:1969:4: otherlv_9= '@' ( (otherlv_10= RULE_ID ) )
            	    {
            	    otherlv_9=(Token)match(input,38,FOLLOW_4); 

            	    				newLeafNode(otherlv_9, grammarAccess.getFullMeshPathAccess().getCommercialAtKeyword_4_0());
            	    			
            	    // InternalMachine.g:1973:4: ( (otherlv_10= RULE_ID ) )
            	    // InternalMachine.g:1974:5: (otherlv_10= RULE_ID )
            	    {
            	    // InternalMachine.g:1974:5: (otherlv_10= RULE_ID )
            	    // InternalMachine.g:1975:6: otherlv_10= RULE_ID
            	    {

            	    						if (current==null) {
            	    							current = createModelElement(grammarAccess.getFullMeshPathRule());
            	    						}
            	    					
            	    otherlv_10=(Token)match(input,RULE_ID,FOLLOW_41); 

            	    						newLeafNode(otherlv_10, grammarAccess.getFullMeshPathAccess().getAnnotationsPathAnnotationCrossReference_4_1_0());
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop45;
                }
            } while (true);

            // InternalMachine.g:1987:3: ( (lv_endPoints_11_0= rulePathTargetReference ) )*
            loop46:
            do {
                int alt46=2;
                int LA46_0 = input.LA(1);

                if ( (LA46_0==RULE_ID) ) {
                    alt46=1;
                }


                switch (alt46) {
            	case 1 :
            	    // InternalMachine.g:1988:4: (lv_endPoints_11_0= rulePathTargetReference )
            	    {
            	    // InternalMachine.g:1988:4: (lv_endPoints_11_0= rulePathTargetReference )
            	    // InternalMachine.g:1989:5: lv_endPoints_11_0= rulePathTargetReference
            	    {

            	    					newCompositeNode(grammarAccess.getFullMeshPathAccess().getEndPointsPathTargetReferenceParserRuleCall_5_0());
            	    				
            	    pushFollow(FOLLOW_7);
            	    lv_endPoints_11_0=rulePathTargetReference();

            	    state._fsp--;


            	    					if (current==null) {
            	    						current = createModelElementForParent(grammarAccess.getFullMeshPathRule());
            	    					}
            	    					add(
            	    						current,
            	    						"endPoints",
            	    						lv_endPoints_11_0,
            	    						"org.eclipse.lsat.machine.teditor.Machine.PathTargetReference");
            	    					afterParserOrEnumRuleCall();
            	    				

            	    }


            	    }
            	    break;

            	default :
            	    break loop46;
                }
            } while (true);

            otherlv_12=(Token)match(input,14,FOLLOW_2); 

            			newLeafNode(otherlv_12, grammarAccess.getFullMeshPathAccess().getRightCurlyBracketKeyword_6());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFullMeshPath"


    // $ANTLR start "entryRulePathTargetReference"
    // InternalMachine.g:2014:1: entryRulePathTargetReference returns [EObject current=null] : iv_rulePathTargetReference= rulePathTargetReference EOF ;
    public final EObject entryRulePathTargetReference() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePathTargetReference = null;


        try {
            // InternalMachine.g:2014:60: (iv_rulePathTargetReference= rulePathTargetReference EOF )
            // InternalMachine.g:2015:2: iv_rulePathTargetReference= rulePathTargetReference EOF
            {
             newCompositeNode(grammarAccess.getPathTargetReferenceRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePathTargetReference=rulePathTargetReference();

            state._fsp--;

             current =iv_rulePathTargetReference; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePathTargetReference"


    // $ANTLR start "rulePathTargetReference"
    // InternalMachine.g:2021:1: rulePathTargetReference returns [EObject current=null] : ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '[' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ']' )? ) ;
    public final EObject rulePathTargetReference() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;


        	enterRule();

        try {
            // InternalMachine.g:2027:2: ( ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '[' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ']' )? ) )
            // InternalMachine.g:2028:2: ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '[' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ']' )? )
            {
            // InternalMachine.g:2028:2: ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '[' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ']' )? )
            // InternalMachine.g:2029:3: () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '[' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ']' )?
            {
            // InternalMachine.g:2029:3: ()
            // InternalMachine.g:2030:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getPathTargetReferenceAccess().getPathTargetReferenceAction_0(),
            					current);
            			

            }

            // InternalMachine.g:2036:3: ( (otherlv_1= RULE_ID ) )
            // InternalMachine.g:2037:4: (otherlv_1= RULE_ID )
            {
            // InternalMachine.g:2037:4: (otherlv_1= RULE_ID )
            // InternalMachine.g:2038:5: otherlv_1= RULE_ID
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getPathTargetReferenceRule());
            					}
            				
            otherlv_1=(Token)match(input,RULE_ID,FOLLOW_15); 

            					newLeafNode(otherlv_1, grammarAccess.getPathTargetReferenceAccess().getPositionSymbolicPositionCrossReference_1_0());
            				

            }


            }

            // InternalMachine.g:2049:3: (otherlv_2= '[' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ']' )?
            int alt48=2;
            int LA48_0 = input.LA(1);

            if ( (LA48_0==21) ) {
                alt48=1;
            }
            switch (alt48) {
                case 1 :
                    // InternalMachine.g:2050:4: otherlv_2= '[' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ']'
                    {
                    otherlv_2=(Token)match(input,21,FOLLOW_4); 

                    				newLeafNode(otherlv_2, grammarAccess.getPathTargetReferenceAccess().getLeftSquareBracketKeyword_2_0());
                    			
                    // InternalMachine.g:2054:4: ( (otherlv_3= RULE_ID ) )
                    // InternalMachine.g:2055:5: (otherlv_3= RULE_ID )
                    {
                    // InternalMachine.g:2055:5: (otherlv_3= RULE_ID )
                    // InternalMachine.g:2056:6: otherlv_3= RULE_ID
                    {

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getPathTargetReferenceRule());
                    						}
                    					
                    otherlv_3=(Token)match(input,RULE_ID,FOLLOW_32); 

                    						newLeafNode(otherlv_3, grammarAccess.getPathTargetReferenceAccess().getSettlingAxisCrossReference_2_1_0());
                    					

                    }


                    }

                    // InternalMachine.g:2067:4: (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )*
                    loop47:
                    do {
                        int alt47=2;
                        int LA47_0 = input.LA(1);

                        if ( (LA47_0==24) ) {
                            alt47=1;
                        }


                        switch (alt47) {
                    	case 1 :
                    	    // InternalMachine.g:2068:5: otherlv_4= ',' ( (otherlv_5= RULE_ID ) )
                    	    {
                    	    otherlv_4=(Token)match(input,24,FOLLOW_4); 

                    	    					newLeafNode(otherlv_4, grammarAccess.getPathTargetReferenceAccess().getCommaKeyword_2_2_0());
                    	    				
                    	    // InternalMachine.g:2072:5: ( (otherlv_5= RULE_ID ) )
                    	    // InternalMachine.g:2073:6: (otherlv_5= RULE_ID )
                    	    {
                    	    // InternalMachine.g:2073:6: (otherlv_5= RULE_ID )
                    	    // InternalMachine.g:2074:7: otherlv_5= RULE_ID
                    	    {

                    	    							if (current==null) {
                    	    								current = createModelElement(grammarAccess.getPathTargetReferenceRule());
                    	    							}
                    	    						
                    	    otherlv_5=(Token)match(input,RULE_ID,FOLLOW_32); 

                    	    							newLeafNode(otherlv_5, grammarAccess.getPathTargetReferenceAccess().getSettlingAxisCrossReference_2_2_1_0());
                    	    						

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop47;
                        }
                    } while (true);

                    otherlv_6=(Token)match(input,22,FOLLOW_2); 

                    				newLeafNode(otherlv_6, grammarAccess.getPathTargetReferenceAccess().getRightSquareBracketKeyword_2_3());
                    			

                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePathTargetReference"


    // $ANTLR start "entryRuleIID"
    // InternalMachine.g:2095:1: entryRuleIID returns [String current=null] : iv_ruleIID= ruleIID EOF ;
    public final String entryRuleIID() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleIID = null;


        try {
            // InternalMachine.g:2095:43: (iv_ruleIID= ruleIID EOF )
            // InternalMachine.g:2096:2: iv_ruleIID= ruleIID EOF
            {
             newCompositeNode(grammarAccess.getIIDRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleIID=ruleIID();

            state._fsp--;

             current =iv_ruleIID.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleIID"


    // $ANTLR start "ruleIID"
    // InternalMachine.g:2102:1: ruleIID returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_INT_0= RULE_INT | this_ID_1= RULE_ID ) ;
    public final AntlrDatatypeRuleToken ruleIID() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_INT_0=null;
        Token this_ID_1=null;


        	enterRule();

        try {
            // InternalMachine.g:2108:2: ( (this_INT_0= RULE_INT | this_ID_1= RULE_ID ) )
            // InternalMachine.g:2109:2: (this_INT_0= RULE_INT | this_ID_1= RULE_ID )
            {
            // InternalMachine.g:2109:2: (this_INT_0= RULE_INT | this_ID_1= RULE_ID )
            int alt49=2;
            int LA49_0 = input.LA(1);

            if ( (LA49_0==RULE_INT) ) {
                alt49=1;
            }
            else if ( (LA49_0==RULE_ID) ) {
                alt49=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 49, 0, input);

                throw nvae;
            }
            switch (alt49) {
                case 1 :
                    // InternalMachine.g:2110:3: this_INT_0= RULE_INT
                    {
                    this_INT_0=(Token)match(input,RULE_INT,FOLLOW_2); 

                    			current.merge(this_INT_0);
                    		

                    			newLeafNode(this_INT_0, grammarAccess.getIIDAccess().getINTTerminalRuleCall_0());
                    		

                    }
                    break;
                case 2 :
                    // InternalMachine.g:2118:3: this_ID_1= RULE_ID
                    {
                    this_ID_1=(Token)match(input,RULE_ID,FOLLOW_2); 

                    			current.merge(this_ID_1);
                    		

                    			newLeafNode(this_ID_1, grammarAccess.getIIDAccess().getIDTerminalRuleCall_1());
                    		

                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleIID"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000002019802L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000002011002L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000004010L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000002010002L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000064000L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000044000L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0000000000104000L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_15 = new BitSet(new long[]{0x0000000000200002L});
    public static final BitSet FOLLOW_16 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_17 = new BitSet(new long[]{0x0000000000A00002L});
    public static final BitSet FOLLOW_18 = new BitSet(new long[]{0x0000000000800002L});
    public static final BitSet FOLLOW_19 = new BitSet(new long[]{0x0000000001000002L});
    public static final BitSet FOLLOW_20 = new BitSet(new long[]{0x0000000004002000L});
    public static final BitSet FOLLOW_21 = new BitSet(new long[]{0x0000000000000050L});
    public static final BitSet FOLLOW_22 = new BitSet(new long[]{0x0000000009000000L});
    public static final BitSet FOLLOW_23 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_24 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_25 = new BitSet(new long[]{0x00000000E0004000L});
    public static final BitSet FOLLOW_26 = new BitSet(new long[]{0x00000000C0000000L});
    public static final BitSet FOLLOW_27 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_28 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_29 = new BitSet(new long[]{0x0000000300004000L});
    public static final BitSet FOLLOW_30 = new BitSet(new long[]{0x0000000200004000L});
    public static final BitSet FOLLOW_31 = new BitSet(new long[]{0x0000010000004010L});
    public static final BitSet FOLLOW_32 = new BitSet(new long[]{0x0000000001400000L});
    public static final BitSet FOLLOW_33 = new BitSet(new long[]{0x0000000004000002L});
    public static final BitSet FOLLOW_34 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_35 = new BitSet(new long[]{0x0000000800000000L});
    public static final BitSet FOLLOW_36 = new BitSet(new long[]{0x0000003000000000L});
    public static final BitSet FOLLOW_37 = new BitSet(new long[]{0x0000004001000002L});
    public static final BitSet FOLLOW_38 = new BitSet(new long[]{0x0000004000000002L});
    public static final BitSet FOLLOW_39 = new BitSet(new long[]{0x0000008000000000L});
    public static final BitSet FOLLOW_40 = new BitSet(new long[]{0x0000004001004010L});
    public static final BitSet FOLLOW_41 = new BitSet(new long[]{0x0000004000004010L});

}